///-----------------------------------------------------------------
///
/// @file      EditorFrm.cpp
/// @author    Martin Sarva
/// Created:   27. 1. 2010 15:26:18
/// @section   DESCRIPTION
///            EditorFrm class implementation
///
///------------------------------------------------------------------

#include "EditorFrm.h"


//Do not add custom headers between
//Header Include Start and Header Include End
//wxDev-C++ designer will remove them
////Header Include Start
#include "Images/EditorFrm_WxToolButton2_XPM.xpm"
#include "Images/EditorFrm_WxToolButton5_XPM.xpm"
#include "Images/EditorFrm_WxToolButton4_XPM.xpm"
#include "Images/EditorFrm_WxToolButton3_XPM.xpm"
#include "Images/EditorFrm_WxToolButton1_XPM.xpm"
////Header Include End

#include <iostream>
#include <sstream>
#include <string>
#include <cstdlib>
#include <stdio.h>
#include <unistd.h>

//#include "tinyxml.h"
using namespace std;

//----------------------------------------------------------------------------
// EditorFrm
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(EditorFrm,wxFrame)
	////Manual Code Start
	//EVT_LEFT_DCLICK(EditorFrm::Onwclick)
	////Manual Code End
	
	EVT_CLOSE(EditorFrm::OnClose)
	EVT_MENU(ID_MNU_OPEN_1016, EditorFrm::WxToolButton1Click0)
	EVT_MENU(ID_MNU_SAVE_1035, EditorFrm::WxToolButton3Click)
	EVT_MENU(ID_MNU_EXIT_1004, EditorFrm::Mnuexit1004Click)
	EVT_MENU(ID_MNU_INCLUDEALGORITHM_1037, EditorFrm::WxToolButton5Click)
	EVT_MENU(ID_MNU_VIEWWITHALGORITHM_1038, EditorFrm::WxToolButton4Click)
	EVT_MENU(ID_MNU_ABOUT_1005, EditorFrm::Mnuabout1005Click)
	EVT_MENU(ID_MNU_HELP_1015, EditorFrm::WxToolButton1Click)
	EVT_MENU(ID_WXTOOLBUTTON2,EditorFrm::WxToolButton1Click)
	EVT_MENU(ID_WXTOOLBUTTON5,EditorFrm::WxToolButton5Click)
	EVT_MENU(ID_WXTOOLBUTTON4,EditorFrm::WxToolButton4Click)
	
	EVT_SPIN_UP(ID_WXSPINBUTTON1,EditorFrm::WxSpinButton1Up)
	EVT_SPIN_DOWN (ID_WXSPINBUTTON1,EditorFrm::WxSpinButton1Down)
	EVT_BUTTON(ID_WXBUTTON1,EditorFrm::WxButton1Click)
	EVT_TOGGLEBUTTON(ID_WXTOGGLEBUTTON3,EditorFrm::WxToggleButton3Click)
	EVT_TOGGLEBUTTON(ID_WXTOGGLEBUTTON2,EditorFrm::WxToggleButton2Click)
	EVT_TOGGLEBUTTON(ID_WXTOGGLEBUTTON1,EditorFrm::WxToggleButton1Click)
	EVT_MENU(ID_WXTOOLBUTTON3,EditorFrm::WxToolButton3Click)
	EVT_MENU(ID_WXTOOLBUTTON1,EditorFrm::WxToolButton1Click0)
END_EVENT_TABLE()
////Event Table End



EditorFrm::EditorFrm(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxFrame(parent, id, title, position, size, style)
{
	CreateGUIControls();
//	this->Connect(wxEVT_PAINT, wxPaintEventHandler(EditorFrm::OnPaint));
//	this->Connect(wxEVT_COMMAND_BUTTON_CLICKED, wxCommandEventHandler(EditorFrm::OnClick));
    this->Connect(wxEVT_CLOSE_WINDOW, wxCloseEventHandler(EditorFrm::OnClose));
    //this->Connect(wxEVT_LEFT_DCLICK, wxMouseEventHandler(EditorFrm::Onwclick));
    
    this->Centre();
    panel1 = new MyPanel(this, WxStaticText2);
    std::stringstream out;
    out << panel1->k;
    std::string str = out.str();
    WxStaticText1->SetLabel(str);
    WxToggleButton1->SetValue(true);
    //ii = 0;
    //panel1->Connect( wxEVT_LEFT_DOWN, wxMouseEventHandler( EditorFrm::onRenderWindowMouseEvents ));

   // wxPanel *panel = new wxPanel(this, -1);

  //st1 = new wxStaticText(panel, -1, wxT(""), wxPoint(10, 10));
 // st2 = new wxStaticText(panel, -1, wxT(""), wxPoint(10, 30));

//  Connect(wxEVT_MOVE, wxMoveEventHandler(EditorFrm::OnMove));

 // Centre();

	
}

MyPanel::MyPanel(wxFrame * parent, wxStaticText *WxStaticTextt)
       : wxPanel(parent, wxID_ANY)
{
    WxStaticTextt->SetLabel(wxT(""));
  WxStaticTexttt = WxStaticTextt;  
  fill = 10;
  x = 0;
  y = 0;
    edgeInserting = false; 
    clicked = NULL;
  k = 1;
  graph = new MyGraph();
  WxStaticText4 = new wxStaticText(this, 2000, wxT("WxStaticText4"), wxPoint(0, 0), wxDefaultSize, 0, wxT("WxStaticText4"));

  //graph = new MyGraph(x,y);
 // slider = new wxSlider(this, ID_SLIDER, 0, 0, 140, wxPoint(50, 30), 
   //   wxSize(-1, 140), wxSL_VERTICAL);

  Connect(wxEVT_LEFT_UP, wxMouseEventHandler(MyPanel::OnClick));  
  Connect(wxEVT_PAINT, wxPaintEventHandler(MyPanel::OnPaint));
  SetBackgroundStyle(wxBG_STYLE_CUSTOM);
  Connect(wxEVT_ERASE_BACKGROUND, wxEraseEventHandler(MyPanel::OnEraseBackground));
  Connect(wxEVT_MOTION, wxMouseEventHandler(MyPanel::OnDrag));
  Connect(wxEVT_LEFT_DOWN, wxMouseEventHandler(MyPanel::OnDown));  
}

EditorFrm::~EditorFrm()
{
}

void EditorFrm::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	wxInitAllImageHandlers();   //Initialize graphic format handlers

	WxToolBar1 = new wxToolBar(this, ID_WXTOOLBAR1, wxPoint(0, 0), wxSize(629, 19));

	wxBitmap WxToolButton1_BITMAP (EditorFrm_WxToolButton1_XPM);
	wxBitmap WxToolButton1_DISABLE_BITMAP (wxNullBitmap);
	WxToolBar1->AddTool(ID_WXTOOLBUTTON1, wxT("Open graph"), WxToolButton1_BITMAP, WxToolButton1_DISABLE_BITMAP, wxITEM_NORMAL, wxT("Open graph"), wxT("Open graph"));

	wxBitmap WxToolButton3_BITMAP (EditorFrm_WxToolButton3_XPM);
	wxBitmap WxToolButton3_DISABLE_BITMAP (wxNullBitmap);
	WxToolBar1->AddTool(ID_WXTOOLBUTTON3, wxT("Save"), WxToolButton3_BITMAP, WxToolButton3_DISABLE_BITMAP, wxITEM_NORMAL, wxT("save"), wxT("Save"));

	WxToggleButton1 = new wxToggleButton(WxToolBar1, ID_WXTOGGLEBUTTON1, wxT("Insert"), wxPoint(48, 0), wxSize(42, 19), 0, wxDefaultValidator, wxT("WxToggleButton1"));
	WxToolBar1->AddControl(WxToggleButton1);

	WxToggleButton2 = new wxToggleButton(WxToolBar1, ID_WXTOGGLEBUTTON2, wxT("Edit Nodes"), wxPoint(90, 0), wxSize(63, 19), 0, wxDefaultValidator, wxT("WxToggleButton2"));
	WxToolBar1->AddControl(WxToggleButton2);

	WxToggleButton3 = new wxToggleButton(WxToolBar1, ID_WXTOGGLEBUTTON3, wxT("Edit Edges"), wxPoint(153, 0), wxSize(60, 19), 0, wxDefaultValidator, wxT("WxToggleButton3"));
	WxToolBar1->AddControl(WxToggleButton3);

	WxButton1 = new wxButton(WxToolBar1, ID_WXBUTTON1, wxT("Delete"), wxPoint(213, 0), wxSize(52, 19), 0, wxDefaultValidator, wxT("WxButton1"));
	WxToolBar1->AddControl(WxButton1);

	WxStaticText1 = new wxStaticText(WxToolBar1, ID_WXSTATICTEXT1, wxT(""), wxPoint(265, 0), wxSize(50, 19), wxALIGN_CENTRE | wxST_NO_AUTORESIZE, wxT("WxStaticText1"));
	WxToolBar1->AddControl(WxStaticText1);

	WxSpinButton1 = new wxSpinButton(WxToolBar1, ID_WXSPINBUTTON1, wxPoint(315, 0), wxSize(30, 19), wxSP_HORIZONTAL, wxT("WxSpinButton1"));
	WxSpinButton1->SetRange(0,100);
	WxSpinButton1->SetValue(0);
	WxToolBar1->AddControl(WxSpinButton1);

	WxStaticText2 = new wxStaticText(WxToolBar1, ID_WXSTATICTEXT2, wxT("WxStaticText2"), wxPoint(345, 0), wxDefaultSize, 0, wxT("WxStaticText2"));
	WxToolBar1->AddControl(WxStaticText2);

	wxArrayString arrayStringFor_WxComboBox1;
	arrayStringFor_WxComboBox1.Add(wxT("--default--"));
	WxComboBox1 = new wxComboBox(WxToolBar1, ID_WXCOMBOBOX1, wxT("--default--"), wxPoint(422, 0), wxSize(124, 23), arrayStringFor_WxComboBox1, 0, wxDefaultValidator, wxT("WxComboBox1"));
	WxToolBar1->AddControl(WxComboBox1);

	wxBitmap WxToolButton4_BITMAP (EditorFrm_WxToolButton4_XPM);
	wxBitmap WxToolButton4_DISABLE_BITMAP (wxNullBitmap);
	WxToolBar1->AddTool(ID_WXTOOLBUTTON4, wxT("View graph"), WxToolButton4_BITMAP, WxToolButton4_DISABLE_BITMAP, wxITEM_NORMAL, wxT(""), wxT("View graph"));

	wxBitmap WxToolButton5_BITMAP (EditorFrm_WxToolButton5_XPM);
	wxBitmap WxToolButton5_DISABLE_BITMAP (wxNullBitmap);
	WxToolBar1->AddTool(ID_WXTOOLBUTTON5, wxT("Import Algorithm"), WxToolButton5_BITMAP, WxToolButton5_DISABLE_BITMAP, wxITEM_NORMAL, wxT(""), wxT("Import Algorithm"));

	wxBitmap WxToolButton2_BITMAP (EditorFrm_WxToolButton2_XPM);
	wxBitmap WxToolButton2_DISABLE_BITMAP (wxNullBitmap);
	WxToolBar1->AddTool(ID_WXTOOLBUTTON2, wxT("Help"), WxToolButton2_BITMAP, WxToolButton2_DISABLE_BITMAP, wxITEM_NORMAL, wxT(""), wxT("Help"));

	WxStatusBar1 = new wxStatusBar(this, ID_WXSTATUSBAR1);
	WxStatusBar1->SetFieldsCount(2);
	WxStatusBar1->SetStatusText(wxT(""),0);
	WxStatusBar1->SetStatusText(wxT("Compound Graphs Editor by Martin Sarva"),1);
	int WxStatusBar1_Widths[2];
	WxStatusBar1_Widths[0] = 100;
	WxStatusBar1_Widths[1] = -1;
	WxStatusBar1->SetStatusWidths(2,WxStatusBar1_Widths);

	WxMessageDialog1 =  new wxMessageDialog(this, wxT("Pom si sm:)"), wxT("help"));

	WxMenuBar1 = new wxMenuBar();
	wxMenu *ID_MNU_File_1002_Mnu_Obj = new wxMenu(0);
	ID_MNU_File_1002_Mnu_Obj->Append(ID_MNU_OPEN_1016, wxT("&Open"), wxT("Open file"), wxITEM_NORMAL);
	ID_MNU_File_1002_Mnu_Obj->Append(ID_MNU_SAVE_1035, wxT("&Save"), wxT(""), wxITEM_NORMAL);
	ID_MNU_File_1002_Mnu_Obj->Append(ID_MNU_EXIT_1004, wxT("E&xit\tAlt/x"), wxT("Quit this program"), wxITEM_NORMAL);
	WxMenuBar1->Append(ID_MNU_File_1002_Mnu_Obj, wxT("&File"));
	
	wxMenu *ID_MNU_VIEW_1036_Mnu_Obj = new wxMenu(0);
	ID_MNU_VIEW_1036_Mnu_Obj->Append(ID_MNU_INCLUDEALGORITHM_1037, wxT("&Include Algorithm"), wxT(""), wxITEM_NORMAL);
	ID_MNU_VIEW_1036_Mnu_Obj->Append(ID_MNU_VIEWWITHALGORITHM_1038, wxT("View &with algorithm"), wxT(""), wxITEM_NORMAL);
	WxMenuBar1->Append(ID_MNU_VIEW_1036_Mnu_Obj, wxT("&View"));
	
	wxMenu *ID_MNU_HELP_1003_Mnu_Obj = new wxMenu(0);
	ID_MNU_HELP_1003_Mnu_Obj->Append(ID_MNU_ABOUT_1005, wxT("&About"), wxT("Show about dialog"), wxITEM_NORMAL);
	ID_MNU_HELP_1003_Mnu_Obj->Append(ID_MNU_HELP_1015, wxT("&Help"), wxT("Need Help?"), wxITEM_NORMAL);
	WxMenuBar1->Append(ID_MNU_HELP_1003_Mnu_Obj, wxT("&Help"));
	SetMenuBar(WxMenuBar1);

	WxOpenFileDialog2 =  new wxFileDialog(this, wxT("Choose a file"), wxT(""), wxT(""), wxT("*.*"), wxOPEN | wxMULTIPLE);

	WxTextEntryDialog1 =  new wxTextEntryDialog( this,wxT(""), wxT("Please enter name of the algorithm"), wxT("") ,wxOK | wxCANCEL | wxCENTRE);

	WxOpenFileDialog1 =  new wxFileDialog(this, wxT("Choose a file"), wxT(""), wxT(""), wxT("*.*"), wxOPEN);

	WxSaveFileDialog1 =  new wxFileDialog(this, wxT("Choose a file"), wxT(""), wxT(""), wxT("*.graphml"), wxSAVE);

	SetStatusBar(WxStatusBar1);
	WxToolBar1->Realize();
	SetToolBar(WxToolBar1);
	SetTitle(wxT("Editor"));
	SetIcon(wxNullIcon);
	SetSize(8,8,645,365);
	Center();
	
	////GUI Items Creation End
}

void EditorFrm::OnClose(wxCloseEvent& event)
{
    wxMessageDialog *dial = new wxMessageDialog(NULL,
      wxT("Are you sure to quit? \n\nNaozaj chcete skoni?"), wxT("Question"),
      wxYES_NO | wxNO_DEFAULT | wxICON_QUESTION);

  int ret = dial->ShowModal();
  dial->Destroy();

  if (ret == wxID_YES) {
     // ~MyGraph();  
      Destroy();
  } else {
      event.Veto();
  }

	//Destroy();            // wxPaintEvent&
}




/*
 * Mnuexit1004Click
 */
void EditorFrm::Mnuexit1004Click(wxCommandEvent& event)
{
	// insert your code here
	Close(true);
}

/*
 * Mnuabout1005Click
 */
void EditorFrm::Mnuabout1005Click(wxCommandEvent& event)
{
	// insert your code here
	wxString msg;
	msg.Printf(
    _T("Welcome to Compound Graph Editor \n version 0.01 \n %s \n Martin Sarva ")
    ,wxVERSION_STRING
    );
	wxMessageBox(msg, _T("About Editor"),wxOK | wxICON_INFORMATION, this);
	
}

/*
 * WxToolButton1Click
 */
void EditorFrm::WxToolButton1Click(wxCommandEvent& event)
{
	// insert your code here
	WxMessageDialog1->ShowModal();
}

/*
 * WxToolButton1Click0
 */
void EditorFrm::WxToolButton1Click0(wxCommandEvent& event)
{
	wxString msg;
	std::stringstream out;
	
	
    if(wxID_OK == WxOpenFileDialog1->ShowModal()){
        TiXmlDocument doc(WxOpenFileDialog1->GetPath());
        bool loadOkay = doc.LoadFile();
	
	
	
        if ( !loadOkay ){
		    msg.Printf(
            _T("Could not load file '"+WxOpenFileDialog1->GetPath()+"'. Error='%s'. Exiting.\n")
            ,doc.ErrorDesc());
            //exit( 1 );
		}else{

            TiXmlPrinter printer;
			doc.Accept( &printer );
		    //const std::string a 
            msg = printer.CStr();
            bool importOK = panel1->graph->ImportGraph(doc, GetClientSize().GetWidth(), GetClientSize().GetHeight());
            if (!importOK){
                msg.Printf(_T("Could not import Graph!\n"));
            }
            msg += panel1->graph->strrr;
            //fprintf( stdout, "%s", printer.CStr() );
	   		//doc.Print( out );
               //std::cout << doc;
	   		//msg = out;
        }	
       //wxPrintPreview preview= new wxPrintPreview(wxPrintout* printout, NULL, wxPrintData* data=NULL);
      //  wxFrame *frame = new wxFrame(NULL, preview, this, _T("Demo Print Preview"), wxPoint(100, 100), wxSize(600, 650));
    //frame->Centre(wxBOTH);
    //frame->Initialize();
    //frame->Show();
//wxWindow *w = new wxWindow(NULL, 5555, wxDefaultPosition, wxSize(600, 650), wxOK|wxVSCROLL, "file");
  //     w->Show();
        wxMessageBox(msg, _T("file"),wxOK | wxICON_INFORMATION, this);
        
        Refresh();
    }
    //;
}


/*
 * WxToolButton3Click
 */
void EditorFrm::WxToolButton3Click(wxCommandEvent& event)
{
    std::stringstream out;
	if(wxID_OK ==WxSaveFileDialog1->ShowModal()){
        wxString path = WxSaveFileDialog1->GetPath();
        wxString disk = path.substr(0,2);
        disk += "\\";
        disk += path.substr(2);
        TiXmlDocument doc(disk); 
        
        if(!panel1->graph->ExportGraph(doc)){
            wxMessageBox("Could not save file '"+WxSaveFileDialog1->GetPath()+"'. Error='%s'. Exiting.\n", _T("file"),wxOK | wxICON_INFORMATION, this);
        }else{
           wxMessageBox(disk, _T("file"),wxOK | wxICON_INFORMATION, this);
        }

        
    
//    ios::cata
//try this one....
//
//int _execl( const char *cmdname, const char *arg0, ... const char *argn,NULL );

//ShellExecute(...)

//#include <stdlib.h>
//int main()
//{
//system("program.exe");
//}


//execute_java_static_method(
//                            0, javaObjectHolder(), "addObject",//main
//                            "(Ljava/lang/Object;)I",
//                            javaObj);//args


}

}

/*
 * WxToolButton4Click
 */
void EditorFrm::WxToolButton4Click(wxCommandEvent& event)
{
    //spusti algoritmus
	wxString xml;
    std::stringstream out;    
        
        //disk+=panel1->graph->strrr;
  //  int i;
//  printf ("Checking if processor is available...");
//  if (system(NULL)) puts ("Ok");
//    else exit (1);
//  printf ("Executing command DIR...\n");
//  i=system ("dir");
//  out << printf ("The value returned was: %d.\n",i);
//disk = out.str();
//     
     //system("D:");
     //system("")
    //system("java HelloWorld");
   // _execl("CGEditor.exe", NULL);
   // if(_execl("D:\\CGEditor.exe", NULL)!=-1){
     //   wxMessageBox(disk, _T("file"),wxOK | wxICON_INFORMATION, this);
       // }else{
        //wxMessageBox("chyba", _T("file"),wxOK | wxICON_INFORMATION, this);    
        //}
    //_execl("D:cmd.exe", "cmd.exe", NULL);
    //system("java \"C:\\Users\\Martin\\Desktop\\!BakPraca\\balaz2007m\\balaz2007\" D:\\a.graphml");
    //system("\"C:\\Program Files\\PowerMenu\\PowerMenu.exe\"-hideself on");
    TiXmlDocument doc("Temp/graph.graphml");
    if(WxComboBox1->GetValue()!="--default--"){
        
        if(panel1->graph->ExportGraph(doc)){
        int j = WxComboBox1->FindString(WxComboBox1->GetValue());
            if(ImportedAlgo.find(j)!=ImportedAlgo.end()){
                if(ImportedAlgo.find(j)->second->type){//java
                //set path environment variable
                    xml = "java ";
                    xml += ImportedAlgo.find(j)->second->name;
                    xml += " Temp/graph.graphml";     
                }else{
                    xml = ImportedAlgo.find(j)->second->name;
                    xml += " Temp/graph.graphml";     
                } 
                //wxMessageBox(xml, _T("file"),wxOK | wxICON_INFORMATION, this);
                char   psBuffer[128];
                FILE   *pPipe;
                 if( (pPipe = _popen( xml, "rt" )) == NULL )
                    exit( 1 ); 
                     /* Read pipe until end of file, or an error occurs. */

                while(fgets(psBuffer, 128, pPipe))
                {
                    out << psBuffer;
                    //printf(psBuffer);
                 }      
                xml = out.str(); 
                /* Close pipe and print return value of pPipe. */
                if (feof( pPipe)){
                    printf( "\nProcess returned %d\n", _pclose( pPipe ) );
                }else{
                    printf( "Error: Failed to read the pipe to the end.\n");
                }

                doc.Parse(xml);
                bool importOK = panel1->graph->ImportGraph(doc, GetClientSize().GetWidth(), GetClientSize().GetHeight());
                if (!importOK){
                    xml.Printf(_T("Could not import Graph!\n"));
                }         
            }
    
    }else{
        xml.Printf(_T("Could not export Graph!\n"));
    }
     Refresh();
    wxMessageBox(xml, _T("file"),wxOK | wxICON_INFORMATION, this);
    }
}

/*
 * WxToolButton5Click
 */
void EditorFrm::WxToolButton5Click(wxCommandEvent& event)
{
	//importuj algoritmus
	wxString name;
	wxString main;
	wxArrayString olda;
	wxArrayString newa;
	if(wxID_OK == WxOpenFileDialog2->ShowModal()){
         WxOpenFileDialog2->GetPaths(olda);
        //newa = "Settings/";
        WxOpenFileDialog2->GetFilenames(newa);
        for(int k =0; k<olda.GetCount();k++ ){
            CopyFile(olda[k], newa[k], false);
        }
        if(olda.GetCount()>1){
            wxSingleChoiceDialog *WxSingleChoiceDialog1;
            wxArrayString arrayStringFor_WxSingleChoiceDialog1;
            for(int k =0; k<olda.GetCount();k++ ){
                arrayStringFor_WxSingleChoiceDialog1.Add(newa[k]);
            }
            WxSingleChoiceDialog1 =  new wxSingleChoiceDialog(this, wxT(""), wxT("Choose the main"), arrayStringFor_WxSingleChoiceDialog1,NULL);
            if(wxID_OK == WxSingleChoiceDialog1->ShowModal()){
                main = WxSingleChoiceDialog1->GetStringSelection();   
               //wxMessageBox(main, _T("file"),wxOK | wxICON_INFORMATION, this); 
            }
        }else{
            main = newa[0];
        }
        if(wxID_OK == WxTextEntryDialog1->ShowModal()){
            name =WxTextEntryDialog1->GetValue(); 
            WxComboBox1->Append(name);
            Algo * algoritmus;
            algoritmus = new Algo();  
            //
            
            if(main.substr(main.Length()-6,6)==".class"){
                algoritmus->name = main.substr(0,main.Length()-6);
                algoritmus->type = true; //is java  
                //wxMessageBox(algoritmus->name, _T("file"),wxOK | wxICON_INFORMATION, this);
            }else{
                algoritmus->name = main;
                algoritmus->type = false;
            }
              //
            ImportedAlgo.insert(pair<int, Algo*>(WxComboBox1->FindString(name),algoritmus));   
        }
    
    }
	
}

//void EditorFrm::OnPaint(wxPaintEvent& event)
//{
//  wxPaintDC dc(this);
//  

//}

//void EditorFrm::OnPaint(wxPaintEvent& event){
//    
// wxBufferedPaintDC dc(panel1);
//  
//  panel1->PaintBackground(dc);
//  
//  wxPen pen(wxColour(212, 212, 212));
//  dc.SetPen(pen);
//
//  //dc.DrawRectangle(wxRect(340, 30, 80, 140));  
//
//  wxBrush brush1(wxColour(197, 108, 0));
//  dc.SetBrush(brush1);
//      Node *current = panel1->graph->base; // prvy vrchol
//    //dc.DrawCircle(xxx, yyy, 10);
//    dc.DrawRoundedRectangle(int(panel1->k*(current->x - current->Width/2)), int(panel1->k*(current->y - current->Height/2)), int(panel1->k*current->Width), int(panel1->k*current->Height),4);
//    panel1->PaintFirstSon(current, &dc);
//  ii++;
//  std::stringstream out;
//    out << ii;
//    
//  
//WxStaticText2->SetLabel(out.str());
////    dc.SetPen(*wxBLACK_PEN);
////    dc.SetBrush(*wxRED_BRUSH);
////
////    // Get window dimensions
////    wxSize sz = wxSize(500,500);
////
////    // Our rectangle dimensions
////    wxCoord w = 100, h = 50;
////
////    // Center the rectangle on the window, but never
////    // draw at a negative position.
////    int x = wxMax(0, (sz.x));
////    int y = wxMax(0, (sz.y));
////
////    wxRect rectToDraw(x, y, w, h);
////
////    // For efficiency, do not draw if not exposed
////    if (IsExposed(rectToDraw))
////        dc.DrawRectangle(wxRect(x,y,w,h));
//}



//void EditorFrm::OnClick(wxCommandEvent& event) 
//{
//
//  //std::cout << "event reached frame class" << std::endl;
//  //event.Skip();
//}

//void EditorFrm::OnMove(wxMoveEvent& event)
//{
//  wxPoint size = event.GetPosition();
//  st1->SetLabel(wxString::Format(wxT("x: %d"), size.x ));
//  st2->SetLabel(wxString::Format(wxT("y: %d"), size.y ));
//}
void EditorFrm::Onwclick(wxMouseEvent& event)
{
    
    wxString msg;
	msg.Printf(
    _T("Welcome to Compound Graph Editor \n version 0.01 \n %s \n Martin Sarva ")
    ,wxVERSION_STRING
    );
	wxMessageBox(msg, _T("About Editor"),wxOK | wxICON_INFORMATION, this);
}

void MyPanel::OnClick(wxMouseEvent& event)
{
//if(parent->WxToggleButton1->GetValue()){
	wxPoint p;

   x = event.m_x;
   y = event.m_y;
   	p.x = int(x/k);
    p.y = int(y/k);
  //fill= fill+10;
  if((graph->insertMode)&&(!graph->editMode)&&(!graph->editEdgeMode)){
    if (graph->number == 0){  
        //graph->curnode->id = number;
        graph->curnode->Width = GetClientSize().GetWidth();
        graph->curnode->Height = GetClientSize().GetHeight();
        graph->curnode->x = graph->curnode->Width/2;
        graph->curnode->y = graph->curnode->Height/2;
        graph->number++;
        
        //graph->curnode->FirstSon = new Node();
//        graph->curnode->FirstSon->id = graph->number;
//        graph->curnode->FirstSon->FirstSon = NULL;
//        //graph->curnode->FirstSon->LastSon = NULL;
//        graph->curnode->FirstSon->LeftBrother = NULL;
//        graph->curnode->FirstSon->RightBrother = NULL;
//        graph->curnode->FirstSon->Father = graph->curnode;
//        graph->curnode->FirstSon->next = NULL;
//        graph->curnode->FirstSon->x = 20;
//        graph->curnode->FirstSon->y = 30;
//        graph->curnode->FirstSon->Width = graph->stdWidth;
//        graph->curnode->FirstSon->Height = graph->stdHeight;
//        //graph->curnode->FirstSon->back=false;
//        graph->number++;
//        
//        graph->curnode->FirstSon->RightBrother = new Node();
//        graph->curnode->FirstSon->RightBrother->id = graph->number;
//        graph->curnode->FirstSon->RightBrother->FirstSon = NULL;
//        //graph->curnode->FirstSon->RightBrother->LastSon = NULL;
//        graph->curnode->FirstSon->RightBrother->LeftBrother = graph->curnode->FirstSon;
//        graph->curnode->FirstSon->RightBrother->RightBrother = NULL;
//        graph->curnode->FirstSon->RightBrother->Father = graph->curnode;
//        graph->curnode->FirstSon->RightBrother->next = NULL;
//        graph->curnode->FirstSon->RightBrother->x = 50;
//        graph->curnode->FirstSon->RightBrother->y = 60;
//        graph->curnode->FirstSon->RightBrother->Width = graph->stdWidth;
//        graph->curnode->FirstSon->RightBrother->Height = graph->stdHeight;
//        //graph->curnode->FirstSon->RightBrother->back=false;
//        graph->number++;
        
    }else{
        //Node *n = new Node();
//        
//        n->x = int(x/k);
//        n->y = int(y/k);
//        n->Width = graph->stdWidth;
//        n->Height = graph->stdHeight;

//        int xx = int(k*(graph->curnode->x - graph->curnode->Width/2));
//        int yy = int(k*(graph->curnode->y - graph->curnode->Height/2));
//        n->x = n->x - xx ;
//        n->y = n->y - yy;
        
        
        
        
 
        graph->FindCurrent(p);
        
        std::stringstream out;
        out << p.x;//n->x;
        out << ", ";
        out << p.y;//n->y;
        strr = out.str();
        //strr =  this->parent->vypis(str);
    //    wxString msg;
//	msg.Printf(
//    _T("Welcome to Compound Graph Editor \n version 0.01 \n %s \n Martin Sarva ")
//    ,wxVERSION_STRING
//    );
//	wxMessageBox(msg, _T("About Editor"),wxOK | wxICON_INFORMATION, this);
	
        if(clicked == graph->curnode){
            graph->push(p);
        }else{
            graph->MakeEdge(clicked, graph->curnode);
        }
        
        
    
    }  
}
if((!graph->insertMode)&&(graph->editMode)&&(!graph->editEdgeMode)){
    //Node *n = new Node();
 //   wxPoint p;
//        
//    p.x = int(x/k);
//    p.y = int(y/k);
    //n->x = int(x/k);
    //n->y = int(y/k);
    //n->Width = graph->stdWidth;
    //n->Height = graph->stdHeight;
    std::stringstream out;
    graph->FindCurrent(p); 
    //if(graph->curnode == graph->FindNode(graph->curnode->id)){
      //  wxMessageBox(graph->strrr, _T("About Editor"),wxOK | wxICON_INFORMATION, this);///out << "ok";
    //}else{
      //  wxMessageBox(_T("neok"), _T("About Editor"),wxOK | wxICON_INFORMATION, this);//out << "neOK"; 
    //} 
        
        //if(graph->curnode->next != NULL){
        //out << graph->curnode->next->id;
        //out << ", ";
        //out << p.y;//n->y;
        //strr = out.str();
        //} 
    //n.delete;
}  

if((!graph->insertMode)&&(!graph->editMode)&&(graph->editEdgeMode)){
    graph->curedge = graph->FindEdge(p);
    
}

WxStaticTexttt->SetLabel(strr);
WxStaticTexttt->SetLabel(graph->strrr);
  //  }
  
  //Node vrchol; 
  //vrchol->
   
//  wxPaintEvent ee =  wxEVT_PAINT;
 //EditorFrm()->refresh();
//  OnPaint(ee);
 //EditorFrm.OnPaint(); 
 Refresh();
//wxPaintEvent( wxEVT_PAINT) ;

    
}

void MyPanel::OnEraseBackground(wxEraseEvent& event)
{
}

void MyPanel::PaintBackground(wxDC& dc)
{
    wxColour backgroundColour = GetBackgroundColour();
        if (!backgroundColour.Ok())
            backgroundColour = wxSystemSettings::GetColour(wxSYS_COLOUR_3DFACE);

    dc.SetBrush(wxBrush(backgroundColour));
    dc.SetPen(wxPen(backgroundColour, 1));

    wxRect windowRect(wxPoint(0, 0), GetClientSize());    

    // We need to shift the client rectangle to take into account
    // scrolling, converting device to logical coordinates    
    //CalcUnscrolledPosition(windowRect.x, windowRect.y,
      //                     & windowRect.x, & windowRect.y);
    dc.DrawRectangle(windowRect);



}
void MyPanel::OnPaint(wxPaintEvent& event)
{
   wxBufferedPaintDC dc(this);
  
  PaintBackground(dc);
  
  wxPen pen(wxColour(0, 0, 0));
  dc.SetPen(pen);

  //dc.DrawRectangle(wxRect(340, 30, 80, 140));  

    wxBrush brush1(wxColour(181, 165, 213));
  //wxBrush brush1(wxColour(0, 0, 255));
  dc.SetBrush(brush1);

 // dc.DrawRectangle(wxRect(340, 30, 80, fill));

//wxPaintDC dc(this);

 //   wxPoint lines[] = { wxPoint(20, 260), wxPoint(100, 260), 
 //         wxPoint(20, 210), wxPoint(100, 210) };
 // wxPoint polygon[] = { wxPoint(130, 140), wxPoint(180, 170), 
 //         wxPoint(180, 140), wxPoint(220, 110), wxPoint(140, 100) };
 // wxPoint splines[] = { wxPoint(240, 170), wxPoint(280, 170), 
//          wxPoint(285, 110), wxPoint(325, 110) };
  
 // dc.DrawEllipse(20, 20, 90, 60);
 // dc.DrawRoundedRectangle(130, 20, 90, 60, 10);
//  dc.DrawArc(240, 40, 340, 40, 290, 20);

  //dc.DrawPolygon(4, polygon);
 // dc.DrawRectangle(20, 120, 80, 50);
 // dc.DrawSpline(4, splines);

 // dc.DrawLines(4, lines);
 // dc.DrawCircle(170, 230, 35);
 // dc.DrawRectangle(250, 200, 60, 60);
     
//     for(int i=100;i<=200;i++ ){
 //     wxCoord x1 = 150, y1 = 160 + i;
//  wxCoord x2 = 290, y2 = 260;

 // dc.DrawLine(x1, y1, x2, y2);
  
 //   }
    //int xxx = graph->base->x;
    //int yyy = graph->base->y;
   // graph->base;
    Node *current = graph->base; // prvy vrchol
    //dc.DrawCircle(xxx, yyy, 10);
      wxBrush brush3(wxColour(255, 255, 255));
    
    //graph->PaintGraph(&dc);
    if(current == graph->curnode){    
      
        //wxBrush brush2(wxColour(255, 0, 0));189
        wxBrush brush4(wxColour(189, 189, 189));
        dc.SetBrush(brush4);
        dc.DrawRoundedRectangle(int(k*(current->x - current->Width/2)),int(k*(current->y - current->Height/2)), int(k*current->Width), int(k*current->Height),4);
        
    }else{
        dc.SetBrush(brush3);
        //dc.SetBrush(brush1);
        dc.DrawRoundedRectangle( int(k*(current->x - current->Width/2)), int(k*(current->y - current->Height/2)), int(k*current->Width), int(k*current->Height),4);
    }
        //PaintFirstSon(current, &dc, 0 - int(k*(current->x - current->Width/2)), 0-int(k*(current->y - current->Height/2)));
        //PaintFirstSon(current, &dc, graph->base->x - graph->base->Width/2, graph->base->y - graph->base->Height/2);
        
        graph->PaintFirstSon(current, &dc);
        graph->PrintEdges(&dc);
        
}




void MyPanel::PaintFirstSon(Node *current, wxBufferedPaintDC *dc, int fax, int fay)
{
    wxBrush brush1(wxColour(181, 165, 213));
  //wxBrush brush1(wxColour(0, 0, 255));
 wxBrush brush2(wxColour(130, 130, 130));
        //wxBrush brush2(wxColour(255, 0, 0));
    while(current->FirstSon != NULL){
        //Node *father = current;
        current = current->FirstSon;//ak nema syna tak sirka std inak 2^k*
        if (current->FirstSon == NULL){
            if(current == graph->curnode){    
                dc->SetBrush(brush2);
                dc->DrawEllipse(fax + int(k*(current->x)) - current->Width/2, fay + int(k*(current->y)) - current->Height/2, current->Width, current->Height);
                
            }else{
                dc->SetBrush(brush1);
                dc->DrawEllipse(fax + int(k*(current->x)) - current->Width/2, fay + int(k*(current->y)) - current->Height/2, current->Width, current->Height);
            }   
        }else{
            if(current == graph->curnode){    
                dc->SetBrush(brush2);
                dc->DrawRoundedRectangle(fax + int(k*(current->x)) - int(k*current->Width/2), fay + int(k*(current->y)) - int(k*current->Height/2), int(k*current->Width), int(k*current->Height),4);
                
            }else{
                dc->SetBrush(brush1);
                dc->DrawRoundedRectangle(fax + int(k*(current->x)) - int(k*current->Width/2), fay + int(k*(current->y)) - int(k*current->Height/2), int(k*current->Width), int(k*current->Height),4);
            }
            
        }   
        Node *current2 = current;
        while(current2->RightBrother != NULL){
            current2 = current2->RightBrother;
            if (current2->FirstSon == NULL){
                if(current2 == graph->curnode){    
                    dc->SetBrush(brush2);
                    dc->DrawEllipse(fax + int(k*(current2->x)) - current2->Width/2, fay + int(k*(current2->y)) - current2->Height/2, current2->Width, current2->Height);
                    
                }else{
                    dc->SetBrush(brush1);
                    dc->DrawEllipse(fax + int(k*(current2->x)) - current2->Width/2, fay + int(k*(current2->y)) - current2->Height/2, current2->Width, current2->Height);
                }
                
                
            }else{
                if(current2 == graph->curnode){    
                    dc->SetBrush(brush2);
                    dc->DrawRoundedRectangle(fax + int(k*(current2->x)) - int(k*current2->Width/2), fay + int(k*(current2->y)) - int(k*current2->Height/2), int(k*current2->Width), int(k*current2->Height),4);
                    
                }else{
                    dc->SetBrush(brush1);
                    dc->DrawRoundedRectangle(fax + int(k*(current2->x)) - int(k*current2->Width/2), fay + int(k*(current2->y)) - int(k*current2->Height/2), int(k*current2->Width), int(k*current2->Height),4);
                }
                
            }   
            
            //dc->DrawEllipse(int(k*(current2->x)) - current2->Width/2, int(k*(current2->y)) - current2->Height/2, current2->Width, current2->Height);
            PaintFirstSon(current2, dc, fax+current2->x- current2->Width/2, fay+current2->y- current2->Height/2);
            //PaintRightBrother(current, dc);
            //paintson
            
        } 
    }
}

//void MyPanel::PaintRightBrother(Node *current, wxBufferedPaintDC *dc)
//{
//    while(current->RightBrother != NULL){
//        current = current->RightBrother;
//        dc->DrawEllipse(current->x - graph->stdWidth/2, current->y - graph->stdHeight/2, current->Width, current->Height);
//        //while(current->FirstSon != NULL){
//            PaintFirstSon(current, dc);
//          //  } 
//    }
//}





/*
 * WxToggleButton1Click
 */
void EditorFrm::WxToggleButton1Click(wxCommandEvent& event)
{
    
	panel1->graph->insertMode = !(panel1->graph->insertMode);
    if(panel1->graph->editMode){
        WxToggleButton2->SetValue(false);
        panel1->graph->editMode = false;
    }
    if(panel1->graph->editEdgeMode){
        WxToggleButton3->SetValue(false);
        panel1->graph->editEdgeMode = false;
    }
	
}



/*
 * WxSpinButton1Up
 */
void EditorFrm::WxSpinButton1Up(wxSpinEvent& event)
{
//wxMessageBox("ahoj" , _T("About Editor"),wxOK | wxICON_INFORMATION, this);
	panel1->k = panel1->k * 2;
	std::stringstream out;
    out << panel1->k;
    std::string str = out.str();
 	WxStaticText1->SetLabel(str);
	Refresh();
}

/*
 * WxSpinButton1Down
 */
void EditorFrm::WxSpinButton1Down(wxSpinEvent& event)
{
	panel1->k = panel1->k / 2;
	std::stringstream out;
    out << panel1->k;
    std::string str = out.str();
 	WxStaticText1->SetLabel(str);
	Refresh();
}

void MyPanel::OnDrag(wxMouseEvent& event){
    wxPoint p;
    p.x = event.m_x;
    p.y = event.m_y;
    
    if((event.m_leftDown)&&(graph->editMode)){
        //if((p.x > (graph->curnode->x - graph->curnode->Width / 2))&&(p.x < (graph->curnode->x + graph->curnode->Width / 2))
        //&&(p.y > (graph->curnode->y - graph->curnode->Height / 2))&&(p.y < (graph->curnode->y + graph->curnode->Height / 2))){
            graph->MoveVertex(graph->curnode, p);
        //}
              
    }
    p = graph->ChangeToRelative(graph->curnode, p);
    // Node *n = new Node();
      //  n->x = mx;
       // n->y = my;
        //n->Width = graph->stdWidth;
        //n->Height = graph->stdHeight;
        //graph->curnode = FindCurrent(n, graph->base);
    //mx = mx - graph->curnode->x;
    //my = my - graph->curnode->y;
    
    
    std::stringstream out;
    
    out << p.x;
    out << ", ";
    out << p.y;
    WxStaticText4->SetLabel(out.str());
    Refresh();
    
    }
    

    



/*
 * WxToggleButton2Click
 */
void EditorFrm::WxToggleButton2Click(wxCommandEvent& event)
{
	panel1->graph->editMode = !(panel1->graph->editMode);
	if(panel1->graph->insertMode){
        WxToggleButton1->SetValue(false);
        panel1->graph->insertMode = false;
    }
    if(panel1->graph->editEdgeMode){
        WxToggleButton3->SetValue(false);
        panel1->graph->editEdgeMode = false;
    }
	
}

/*
 * WxButton1Click
 */
void EditorFrm::WxButton1Click(wxCommandEvent& event)
{
    if((panel1->graph->editMode)&&(!panel1->graph->editEdgeMode)){
	   panel1->graph->FindCurrent(panel1->graph->DeleteNode(panel1->graph->curnode));
    }
    if((!panel1->graph->editMode)&&(panel1->graph->editEdgeMode)&&(panel1->graph->curedge!=NULL)){
        panel1->graph->DeleteEdge(panel1->graph->curedge);
    }
    Refresh();
}
void MyPanel::OnDown(wxMouseEvent& event){
    wxPoint p;
        
    p.x = event.m_x;
    p.y = event.m_y;
    if(((graph->insertMode)||(graph->editMode))&&(!graph->editEdgeMode)){
        graph->FindCurrent(p);
        clicked = graph->curnode;
    }
    
}

/*
 * WxToggleButton3Click
 */
void EditorFrm::WxToggleButton3Click(wxCommandEvent& event)
{
		panel1->graph->editEdgeMode = !(panel1->graph->editEdgeMode);
	if(panel1->graph->insertMode){
        WxToggleButton1->SetValue(false);
        panel1->graph->insertMode = false;
    }
    if(panel1->graph->editMode){
        WxToggleButton2->SetValue(false);
        panel1->graph->editMode = false;
    }
}




