///-----------------------------------------------------------------
///
/// @file      EditorFrm.h
/// @author    Martin Sarva
/// Created:   27. 1. 2010 15:26:18
/// @section   DESCRIPTION
///            EditorFrm class declaration
///
///------------------------------------------------------------------

#ifndef __EDITORFRM_H__
#define __EDITORFRM_H__

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
	#include <wx/frame.h>
#else
	#include <wx/wxprec.h>
#endif

//Do not add custom headers between 
//Header Include Start and Header Include End.
//wxDev-C++ designer will remove them. Add custom headers after the block.
////Header Include Start
#include <wx/textdlg.h>
#include <wx/filedlg.h>
#include <wx/menu.h>
#include <wx/msgdlg.h>
#include <wx/statusbr.h>
#include <wx/combobox.h>
#include <wx/spinbutt.h>
#include <wx/stattext.h>
#include <wx/button.h>
#include <wx/tglbtn.h>
#include <wx/toolbar.h>
////Header Include End
#include "MyGraph.h"
#include <wx/dcbuffer.h>

#include <iostream>
#include <sstream>
#include <string>
////Dialog Style Start
#undef EditorFrm_STYLE
#define EditorFrm_STYLE wxCAPTION | wxRESIZE_BORDER | wxSYSTEM_MENU | wxMINIMIZE_BOX | wxMAXIMIZE_BOX | wxCLOSE_BOX
////Dialog Style End


struct Algo
{
    //int id;
    wxString name;
    bool type;
    
};

class MyPanel : public wxPanel
{
public:
    MyPanel(wxFrame *parent, wxStaticText *WxStaticTextt);

    void OnPaint(wxPaintEvent& event);
    void OnClick(wxMouseEvent& event);
    void OnDown(wxMouseEvent& event);
    void OnDrag(wxMouseEvent& event);
    void OnEraseBackground(wxEraseEvent& event);
    void PaintBackground(wxDC& dc);
    void PaintFirstSon(Node *current, wxBufferedPaintDC *dc, int fax, int fay);
   // void PaintRightBrother(Node *current, wxBufferedPaintDC *dc);

    

    //wxSlider *slider;
    wxStaticText *WxStaticText4;
    wxStaticText *WxStaticTexttt;
    int fill;
    int x;
    int y;
    
    float k; //koeficient zoomu
    wxString strr;
    int mx;
    int my;
    MyGraph* graph;
    Node *clicked;
    bool edgeInserting;

    
    

};

class EditorFrm : public wxFrame
{
	private:
		DECLARE_EVENT_TABLE();
		
	public:
		EditorFrm(wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("Editor"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = EditorFrm_STYLE);
		virtual ~EditorFrm();
		void Mnuhelp1003Click(wxCommandEvent& event);
		void Mnuexit1004Click(wxCommandEvent& event);
		void Mnuabout1005Click(wxCommandEvent& event);
		void WxToolButton1Click(wxCommandEvent& event);
		void WxToolButton1Click0(wxCommandEvent& event);
		void WxPanel2UpdateUI(wxUpdateUIEvent& event);
		//void OnPaint(wxPaintEvent& event);
		//void OnClick(wxCommandEvent& event);
		void Onwclick(wxMouseEvent& event);
		void WxToggleButton1Click(wxCommandEvent& event);
		void WxSpinButton1Up(wxSpinEvent& event);
		void WxSpinButton1Down(wxSpinEvent& event);
		void WxToggleButton2Click(wxCommandEvent& event);
		void WxButton1Click(wxCommandEvent& event);
		void WxToggleButton3Click(wxCommandEvent& event);
		void WxToolButton3Click(wxCommandEvent& event);
		void WxToolButton4Click(wxCommandEvent& event);
		void WxToolButton5Click(wxCommandEvent& event);
//	int ii;	
		//wxToggleButton *WxToggleButton1;
       // void OnMove(wxMoveEvent & event);
map<int, Algo*> ImportedAlgo;
  //wxStaticText *st1;
 // wxStaticText *st2;


		
		
	private:
		//Do not add custom control declarations between
		//GUI Control Declaration Start and GUI Control Declaration End.
		//wxDev-C++ will remove them. Add custom code after the block.
		////GUI Control Declaration Start
		wxFileDialog *WxSaveFileDialog1;
		wxFileDialog *WxOpenFileDialog1;
		wxTextEntryDialog *WxTextEntryDialog1;
		wxFileDialog *WxOpenFileDialog2;
		wxMenuBar *WxMenuBar1;
		wxMessageDialog *WxMessageDialog1;
		wxStatusBar *WxStatusBar1;
		wxComboBox *WxComboBox1;
		wxStaticText *WxStaticText2;
		wxSpinButton *WxSpinButton1;
		wxStaticText *WxStaticText1;
		wxButton *WxButton1;
		wxToggleButton *WxToggleButton3;
		wxToggleButton *WxToggleButton2;
		wxToggleButton *WxToggleButton1;
		wxToolBar *WxToolBar1;
		////GUI Control Declaration End
		MyPanel *panel1;

	private:
		//Note: if you receive any error with these enum IDs, then you need to
		//change your old form code that are based on the #define control IDs.
		//#defines may replace a numeric value for the enum names.
		//Try copy and pasting the below block in your old form header files.
		enum
		{
			////GUI Enum Control ID Start
			ID_MNU_File_1002 = 1002,
			ID_MNU_OPEN_1016 = 1016,
			ID_MNU_SAVE_1035 = 1035,
			ID_MNU_EXIT_1004 = 1004,
			ID_MNU_VIEW_1036 = 1036,
			ID_MNU_INCLUDEALGORITHM_1037 = 1037,
			ID_MNU_VIEWWITHALGORITHM_1038 = 1038,
			ID_MNU_HELP_1003 = 1003,
			ID_MNU_ABOUT_1005 = 1005,
			ID_MNU_HELP_1015 = 1015,
			
			ID_WXSTATUSBAR1 = 1011,
			ID_WXTOOLBUTTON2 = 1010,
			ID_WXTOOLBUTTON5 = 1034,
			ID_WXTOOLBUTTON4 = 1033,
			ID_WXCOMBOBOX1 = 1032,
			ID_WXSTATICTEXT2 = 1023,
			ID_WXSPINBUTTON1 = 1022,
			ID_WXSTATICTEXT1 = 1021,
			ID_WXBUTTON1 = 1029,
			ID_WXTOGGLEBUTTON3 = 1030,
			ID_WXTOGGLEBUTTON2 = 1028,
			ID_WXTOGGLEBUTTON1 = 1017,
			ID_WXTOOLBUTTON3 = 1031,
			ID_WXTOOLBUTTON1 = 1009,
			ID_WXTOOLBAR1 = 1007,
			////GUI Enum Control ID End
			ID_DUMMY_VALUE_ //don't remove this value unless you have other enum values
		};
		
	private:
		void OnClose(wxCloseEvent& event);
		void CreateGUIControls();
};

#endif
