
///-----------------------------------------------------------------
///
/// @file      MyGraph.cpp
/// @author    Martin Sarva
/// Created:   25. 2. 2010 13:17:18
/// @section   DESCRIPTION
///            Node class implementation
///
///------------------------------------------------------------------

#include "MyGraph.h"
#include <iostream>
#include <sstream>
#include <string>
#include <stdlib.h> 



MyGraph::MyGraph()
        //:base(NULL),curnode(NULL)
    {
       base = new Node();
       curnode = base;
       curedge = NULL;
       //uppernode = NULL;
       stdtolerant = 6;
       numedge = 0;
       number = 0;
       stdWidth = 40;
       stdHeight = 40;
       minWib = 10;  //minimalne medzery medzi vrcholmi
       minHeb = 10;
       base->id = number;
       base->LeftBrother = NULL;
       base->RightBrother = NULL;
       base->FirstSon = NULL;
 //      base->LastSon = NULL;
       base->Father = NULL;
       base->next = NULL;
       base->x = 0;
       base->y = 0;
       base->Width = 0;
       base->Height = 0;
        base->collapsed = false;
          insertMode = true;
          editMode = false;
          editEdgeMode = false;
        //base->back=false;


//
//    
    }
    
int MyGraph::push(wxPoint p){
    Node *n = new Node();
    
    if(curnode != NULL){
        p = ChangeToRelative(curnode, p);
    }
    
    n->x = p.x;
    n->y = p.y;
//    n->Width = stdWidth;
 //   n->Height = stdHeight;
    
    if(curnode->FirstSon==NULL){            //pridaj mu prveho syna
   //     curnode->FirstSon = new Node();
        
        curnode->FirstSon = n;
        //curnode->LastSon = n;
 
        curnode->FirstSon->id = number;
        curnode->FirstSon->Width = stdWidth;
        curnode->FirstSon->Height = stdHeight;
        curnode->FirstSon->LeftBrother = NULL;
        curnode->FirstSon->RightBrother = NULL;
       // curnode->FirstSon->LastSon = NULL; 
        curnode->FirstSon->FirstSon = NULL;
        curnode->FirstSon->Father = curnode;
        curnode->FirstSon->collapsed = false;
        curnode->FirstSon->next = NULL;
        //curnode->FirstSon->back=false;
        number++;    
        
    }else{
        Node *current = curnode->FirstSon;
        while (current->RightBrother != NULL){       //ak ma prveho syna tak ho pridaj ako posledneho praveho brata a posledneho syna
            current = current->RightBrother;
        }
       // curnode->LastSon = n;
        current->RightBrother = n;
        current->RightBrother->id = number;
        current->RightBrother->Width = stdWidth;
        current->RightBrother->Height = stdHeight;
        current->RightBrother->LeftBrother = current;
        current->RightBrother->RightBrother = NULL;
        current->RightBrother->FirstSon = NULL;
        //current->RightBrother->LastSon = NULL;
        current->RightBrother->Father = curnode;
        current->RightBrother->collapsed = false;
        current->RightBrother->next = NULL;
        //current->RightBrother->back=false;
        number++;
                
    } 
    

    EmBiggerNode(n, curnode);
return number-1;
//    if (number == 0){  
//        //graph->curnode->id = number;
//        curnode->x = 0;
//        curnode->y = 0;
//        //curnode->Width = GetClientSize().GetWidth();
//        //curnode->Height = GetClientSize().GetHeight();
//        number++;
//
//    
//    }else{ 
   // LastSon
    //RightBrother
    
 //       if((curnode->x < x)&&(x < (curnode->Width+curnode->x))&&
   //     (curnode->y < y)&&(y < (curnode->Height+curnode->y)))
   // {
        //curnode->FirstSon = new Node;
       // curnode->LastSon = curnode->FirstSon;
        //uppernode = curnode;
      //  curnode = curnode->FirstSon;
         
  //  }else{
      //  curnode->RightBrother = new Node;
        //uppernode->LastSon = curnode->RightBrother;
     //   curnode = curnode->RightBrother;
  //  }      
  //  curnode->x = x;
  //  curnode->y = y; 
  ///  curnode->Width = stdWidth;
   // curnode->Height = stdHeight; 
   // number++;    
  //  curnode->LeftBrother = NULL;
  //  curnode->RightBrother = NULL;
   // curnode->FirstSon = NULL;
  //  curnode->LastSon = NULL; 
  //}
    //base = vrchol;
    
}

//bod v absolutnom 
int MyGraph::push(wxPoint p, int w, int h, Node *curnode1){
    Node *n = new Node();
    
    if(curnode1 != NULL){
        p = ChangeToRelative(curnode1, p);
    }
    
    n->x = p.x;
    n->y = p.y;
    n->Width = w;
    n->Height = h;
    
    if(curnode1->FirstSon==NULL){            //pridaj mu prveho syna
   //     curnode->FirstSon = new Node();
        
        curnode1->FirstSon = n;
        //curnode->LastSon = n;
 
        curnode1->FirstSon->id = number;
        curnode1->FirstSon->Width = w;
        curnode1->FirstSon->Height = h;
        curnode1->FirstSon->LeftBrother = NULL;
        curnode1->FirstSon->RightBrother = NULL;
       // curnode->FirstSon->LastSon = NULL; 
        curnode1->FirstSon->FirstSon = NULL;
        curnode1->FirstSon->Father = curnode1;
        curnode1->FirstSon->collapsed = false;
        curnode1->FirstSon->next = NULL;
        //curnode1->FirstSon->back=false;
        number++;    
        
    }else{
        Node *current = curnode1->FirstSon;
        while (current->RightBrother != NULL){       //ak ma prveho syna tak ho pridaj ako posledneho praveho brata a posledneho syna
            current = current->RightBrother;
        }
       // curnode->LastSon = n;
        current->RightBrother = n;
        current->RightBrother->id = number;
        current->RightBrother->Width = w;
        current->RightBrother->Height = h;
        current->RightBrother->LeftBrother = current;
        current->RightBrother->RightBrother = NULL;
        current->RightBrother->FirstSon = NULL;
        //current->RightBrother->LastSon = NULL;
        current->RightBrother->Father = curnode1;
        current->RightBrother->collapsed = false;
        current->RightBrother->next = NULL;
        //current->RightBrother->back=false;
        number++;
                
    } 
    

    //EmBiggerNode(n, curnode);
 return number-1;
    
}
//class Node 
//{
//public:
//    Node(int x,int y);
//    ~Node();
//    
////    void OnPaint(wxPaintEvent& event);
////    void OnClick(wxMouseEvent& event);
////    void OnEraseBackground(wxEraseEvent& event);
////    void PaintBackground(wxDC& dc);
//
//  //  Node *LeftBrother;
////    Node *RightBrother;
////    Node *FirstSon;
////    Node *LastSon;
//    int x;
//    int y;
//
//};


//vstup bod, s ktorm chceme zisti konkrtny vrchol na ktor sme klikli
// vystup nie je... zmen sa aktulny vrchol v truktre(currnode)
void MyGraph::FindCurrent(wxPoint p){
    
    bool finding = true;
    bool brothers = true;
    if(((base->x - base->Width / 2) < p.x)&&(p.x < (base->x + base->Width / 2))&&
    (((base->y) - base->Height / 2) < p.y)&&(p.y < (base->Height / 2 + base->y))){
        wxPoint pp = ChangeToRelative(base, p);
        curnode = base;
            
        while(finding){
            brothers = true;
            if (curnode->FirstSon != NULL){
                Node *curr = curnode->FirstSon;
                
                if(((curnode->FirstSon->x - curnode->FirstSon->Width / 2) < pp.x)&&(pp.x < (curnode->FirstSon->x + curnode->FirstSon->Width / 2))&&
                (((curnode->FirstSon->y) - curnode->FirstSon->Height / 2) < pp.y)&&(pp.y < (curnode->FirstSon->Height / 2 + curnode->FirstSon->y))){
                    curnode = curnode->FirstSon;
                    brothers = false;
                }
                       
                
                while ((curr->RightBrother != NULL)&&(brothers)){
                    curr = curr->RightBrother;
                    if(((curr->x - curr->Width / 2) < pp.x)&&(pp.x < (curr->x + curr->Width / 2))&&
                    (((curr->y) - curr->Height / 2) < pp.y)&&(pp.y < (curr->Height / 2 + curr->y))){
                        curnode = curr;
                        brothers = false;
                    }   
                }
                if(brothers){
                    finding = false;        
                }
            }else{
                finding = false;    
            }
            pp = ChangeToRelative(curnode, p);
        
        }
        
    }        
    
    
    //if (current == NULL){
//        return NULL;
//    }
//    Node *newCurrent = NULL;
//    wxPoint pp = ChangeToRelative(current, p);//p
//    //if(!insertMode){
//        //if(current->Father != NULL){
//           // pp = 
//        //}
//        
//        if(((current->x - current->Width / 2) < pp.x)&&(pp.x < (current->x + current->Width / 2))&&
//        (((current->y) - current->Height / 2) < pp.y)&&(pp.y < (current->Height / 2 + current->y))){        
//            if (current->FirstSon != NULL){
//                //p.x = p.x - (current->x - current->Width / 2);
//                //p.y = p.y - (current->y - current->Height / 2);
//                newCurrent = FindCurrent(p , current->FirstSon);
//                //ak to nie je prvy syn skus vsetkych jeho bratov
//                if (newCurrent == NULL){
//                    Node *curr = current->FirstSon;
//                    while ((curr->RightBrother != NULL)&&(newCurrent == NULL)){
//                        curr = curr->RightBrother;
//                        newCurrent = FindCurrent(p , curr);
//                    }
//                }
//            }
//            //ak nema syna alebo ziaden zo synov to nie je vrat current
//            if(newCurrent == NULL){ 
//                newCurrent = current;
//            }
//        }
//        return newCurrent;
    //}
    
    //current->Height / 2;
    //std::cout << "hello";
    //www = current->x + www;
   // std::stringstream out;
//    out << "www=";
//    out << www;
//    out << " ";
//    out << "hh=";
//    out << hh;
//    out << " cur x=";
//    out << current->x;
//    out << " cur y=";
//    out << current->y;
//    out << "width=";
//    out << current->Width;
//    out << "height=";
//    out << current->Height;
//    out << " x=";
//    out << x;
//    std::string wh = out.str();
//    std::string  str ("aa");// 
//    str = wh + " bb";
   //str = strcat(str, "ahoj");
	//wxMessageBox(str , _T("About Editor"),wxOK | wxICON_INFORMATION, this);
//	if(false){//insertMode){
//        int ww = current->Width / 2;
//        int hh = current->Height / 2; 
//    if (current->FirstSon == NULL){
//       // ww = int(ww / k);
//       // hh = int(hh / k) ;
//    }
//    if((current == base)||
//    (((current->x - ww) < p.x)&&(p.x < (current->x + ww))&&
//    (((current->y) - hh) < p.y)&&(p.y < (hh + current->y)))){
//        
//        
//        
//     //   &&(x < (current->x + ww))&&
//  //  ((current->y - hh) < y)&&(y < (hh + current->y))){}
//        if (current->FirstSon != NULL){
//            p.x = p.x - (current->x - current->Width / 2);
//            p.y = p.y - (current->y - current->Height / 2);
//            newCurrent = FindCurrent(p , current->FirstSon);
//            
//            if ((newCurrent != NULL)&&(insertMode)){
//                EmBiggerNode(current->FirstSon , current);
//            } 
//            if (newCurrent == NULL){ //ak to nie je prvy syn tak skusme bratov
//                Node *curr = current->FirstSon;
//                while ((curr->RightBrother != NULL)&&(newCurrent == NULL)){
//                    curr = curr->RightBrother;
//                    //n->x = n->x + curr->x - curr->Width / 2;
//                    //n->y = n->y + curr->y - curr->Height / 2;
//                    newCurrent = FindCurrent(p , curr);
//                }
//                if ((newCurrent != NULL)&&(insertMode)){
//                EmBiggerNode(curr , current);
//                }
//                
//            }
//            
//        }
//        if(newCurrent == NULL){ //ak je toto ten do ktoreho vkladam
//            newCurrent = current;
//            if(insertMode){
//                //n->x = n->x + current->FirstSon->x - current->FirstSon->Width / 2;
//                //n->y = n->y + current->FirstSon->y - current->FirstSon->Height / 2;
//                
//                //-------------EmBiggerNode(n , current);
//            
//            }
//        }
//
//        //if(newCurrent == NULL){   //priamy otec noveho
////            EmBiggerNode(n , current);
////            
////            
////        }else{   //dalsi otcovia
////            EmBiggerNode(current->FirstSon, current);//skontroluj prveho syna 
////            
////        }
//        
////////////////////////////////////////////////////////////////////////           
//    }//else{
//       // if (current->RightBrother != NULL){
////            //current = current->RightBrother;
////            newCurrent = FindCurrent(n , current->RightBrother);
//// //-------------//ak vkladam
////
////            if(newCurrent != NULL){
////                EmBiggerNode(current->FirstSon->RightBrother, current);//skontroluj praveho brata
////            }
////        }
////        if(newCurrent == NULL){
////            return NULL;
////                
////        }   
////    
////    }
//////////////////////////////////////////////    
//    
//    
//  //  if(newCurrent == NULL){
//    //    return current;
//   // }else{
//        return newCurrent;
//  //  }
//    }
}

Node *MyGraph::FindNode(int id){
    Node *fnode = base;
    //Node *finalnode = NULL;
    
   // std::stringstream out;
    //out << fnode->id;
    //if(fnode->id == id) return fnode;
    //if((fnode->FirstSon != NULL)){//&&(!fnode->back)
      //          fnode = fnode->FirstSon;
                
    ///}
    while(fnode->id != id){//fnode->Father != NULL){//){
       // if(fnode->id == id){ 
         //   return fnode;
           // finalnode = fnode;
            //break;
        //}
       // if(fnode->id == id) return fnode;
        //fnode->back = true;       
        //out << fnode->id;
        
        if((fnode->FirstSon != NULL)){//&&(!fnode->back)
                fnode = fnode->FirstSon;
        }else{
            if(fnode->RightBrother != NULL){
                fnode = fnode->RightBrother;
            }else{
                
                while(fnode->LeftBrother!= NULL){
                   // fnode->back = false;
                    fnode = fnode->LeftBrother;
                    
                } 
                if(fnode->Father != NULL){
                    if(fnode->Father->RightBrother != NULL){
                      //  fnode->back = false;
                        fnode = fnode->Father->RightBrother;
                    }else{
                        while((fnode->Father != NULL)&&(fnode->Father->RightBrother == NULL)){
                          //  fnode->back = false;
                            fnode = fnode->Father;
                        }
                        if(fnode->Father == NULL){
                            break;
                        }else{
                            fnode = fnode->Father->RightBrother;
                        }
                    }
                }else{
                    break;//return NULL;
                }
            }
        }
        
    }   
    if(fnode->id == id){ 
        return fnode;
    }else{
        return NULL;
    } 
    //strrr = out.str();
   //return finalnode;
}
int MyGraph::FindNumberFreeX(int a, int b, int y, int h){
    //a>b
    
    //ak presahuje hlavny tak vrat 0 ak presahuje iny tak posun otca
    int fx = a-b;
//    if(a - fx < 0){
//        return 0;
//    }
    return fx;
    
    }

int MyGraph::FindNumberFreeY(int a, int b, int x, int w){
    //a>b
        //ak presahuje hlavny tak vrat 0 ak presahuje iny tak posun otca
    int fx = a-b;
   // if(a - fx < 0){
//        return 0;
//    }
    return fx;
    
    }
    
void MyGraph::Shiftx(Node *n, int frx){
        if(n->FirstSon != NULL){
            n = n->FirstSon;
            while (n != NULL){
                n->x = n->x + frx;
                UpdateLineEquation(n);
                n = n->RightBrother; 
            }
        }
    }
void MyGraph::Shifty(Node *n, int fry){
        if(n->FirstSon != NULL){
            n = n->FirstSon;
            while (n != NULL){
                n->y = n->y + fry;
                UpdateLineEquation(n);
                n = n->RightBrother; 
            }
        }
    }
void MyGraph::EmBiggerNode(Node *n, Node *current){
    int ww = current->Width / 2;
    int hh = current->Height / 2;
    int rmx = current->x - current->Width / 2;
    int rmy = current->y - current->Height / 2;
    bool changed = false;
    if((current->x - ww) > n->x + rmx- n->Width/2 - minWib){
        int frx = FindNumberFreeX(current->x - ww, n->x + rmx- n->Width/2 - minWib, current->y, current->Height);//najdi pocet kolko sa mozem bezpecne posunut
        current->x = current->x - frx/2 ;//  - graph->minWib;  //posun hranice vrcholu
        //ak je base tak posun vsetky...ak su dva vedla seba tak zvacsi k
        Shiftx(current, frx);
        current->Width = current->Width + frx;  
        changed = true;          
    }
    ww = current->Width / 2;
    if((current->x + ww) < n->x + rmx + n->Width/2 + minWib){
        int frxx = FindNumberFreeX(n->x + rmx + n->Width/2 + minWib, current->x + ww, current->y, current->Height);//najdi pocet kolko sa mozem bezpecne posunut
        current->x = current->x + frxx/2;//  + graph->minWib;  //posun hranice vrcholu
        current->Width = current->Width + frxx;   
        changed = true;           
    } 
            
            if((current->y - hh) > n->y + rmy- n->Height/2 - minHeb){
                int fry = FindNumberFreeY(current->y - hh, n->y + rmy- n->Height/2 - minHeb, current->x, current->Width);//najdi pocet kolko sa mozem bezpecne posunut
                current->y = current->y - fry/2 ;//  - graph->minWib;  //posun hranice vrcholu
                Shifty(current, fry);
                current->Height = current->Height + fry;    
                changed = true;          
            }
            hh = current->Height / 2;
            if((current->y + hh) < n->y + rmy+ n->Height/2 + minHeb){
                int fryy = FindNumberFreeY(n->y + rmy+ n->Height/2 + minHeb, current->y + hh, current->x, current->Width);//najdi pocet kolko sa mozem bezpecne posunut
                current->y = current->y + fryy/2;//  + graph->minWib;  //posun hranice vrcholu
                current->Height = current->Height + fryy;  
                changed = true;            
            }   
        if(changed){
            UpdateLineEquation(current);
            if(current->Father != NULL){
                EmBiggerNode(current, current->Father);    
            }
        }
    
    }
   
   // vstup je vrchol a absoltna sradnica, ktor treba pretrabsformova vzhadom k danmu vrcholu
   //vstup je nov relatvna sradnica k danmu vrcholu
   // 
wxPoint MyGraph::ChangeToRelative(Node *currnode1, wxPoint p){
        if(currnode1->Father != NULL){
            p = ChangeToRelative(currnode1->Father, p);
            p.x = p.x - (currnode1->x - currnode1->Width / 2);
            p.y = p.y - (currnode1->y - currnode1->Height / 2);
            return p;
        }else{
            p.x = p.x - (currnode1->x - currnode1->Width / 2);
            p.y = p.y - (currnode1->y - currnode1->Height / 2);
            return p;
        }
    }    
    
    
wxPoint MyGraph::ChangeToAbsolute(Node *currnode, wxPoint p){
        if(currnode->Father != NULL){
            p = ChangeToAbsolute(currnode->Father, p);
            p.x = p.x + (currnode->x - currnode->Width / 2);
            p.y = p.y + (currnode->y - currnode->Height / 2);
            return p;
        }else{
            p.x = p.x + (currnode->x - currnode->Width / 2);
            p.y = p.y + (currnode->y - currnode->Height / 2);
            return p;
        }
    } 

    //vstup: bod v absoltnych sradniciach, vrchol ktormu treba zmeni sradnice
    //vstup: zmenen sradnice vrchola a aktualizovan vetky rovnice priamok pre hrany 
void MyGraph::MoveVertex(Node *currnode1, wxPoint p){
    if(currnode1->Father != NULL){
        p = ChangeToRelative(currnode1->Father, p);
    }
    currnode1->x = p.x;
    currnode1->y = p.y;
   // Pedge *ppp = currnode->next;
    UpdateLineEquation(currnode1);

}
  //vstup: vrchol, ktormu treba zaktualizova vetky rovnice priamok
  // vstup: aktualizovan rovnice priamok
void MyGraph::UpdateLineEquation(Node *nn){
    while(nn != NULL){
        Pedge *ppp = nn->next;
    
        while(ppp!=NULL){
            it = edges.find(ppp->id);
            wxPoint s;
            wxPoint t;
            s.x = it->second->Source->x;
            s.y = it->second->Source->y + it->second->Source->Height/2;
            t.x = it->second->Target->x;
            t.y = it->second->Target->y - it->second->Target->Height/2;
            if(it->second->Source->Father != NULL){
                s = ChangeToAbsolute(it->second->Source->Father, s);
            }
            if(it->second->Target->Father != NULL){
                t = ChangeToAbsolute(it->second->Target->Father, t);
            }
            it->second->l = MakeLineEquation(s,t);
            ppp = ppp->next;
        }
            
        if(nn->RightBrother != NULL){
            UpdateLineEquation(nn->RightBrother);        
        }
        nn = nn->FirstSon;    
    }
    
    
}  
    
void MyGraph::PaintGraph(wxBufferedPaintDC *dc)
{
    wxBrush brush1(wxColour(181, 165, 213));
  //wxBrush brush1(wxColour(0, 0, 255));
    wxBrush brush2(wxColour(130, 130, 130)); 
    Node *currentt = base;
    Node *currentt2 = base;
    wxPoint p;
    p.x = currentt->x;
    p.y = currentt->y;
    
    wxPoint pp = ChangeToAbsolute(currentt, p);
    dc->DrawRoundedRectangle(p.x - currentt->Width/2, p.y - currentt->Height/2, currentt->Width, currentt->Height,4);

    while(currentt->FirstSon != NULL){
        currentt = currentt->FirstSon;
        p.x = currentt->x;
        p.y = currentt->y;
        pp = ChangeToAbsolute(currentt->Father, p);
        dc->DrawRoundedRectangle(pp.x - currentt->Width/2, pp.y - currentt->Height/2, currentt->Width, currentt->Height,4);

        currentt2 = currentt;
        while(currentt2->RightBrother != NULL){
            currentt2 = currentt2->RightBrother;
            p.x = currentt2->x - currentt2->Width/2;
            p.y = currentt2->y - currentt2->Height/2;
            pp = ChangeToAbsolute(currentt2->Father, p);
            dc->DrawEllipse(pp.x, pp.y, currentt2->Width, currentt2->Height);

        }
        
    }    
    
}
    
 void MyGraph::PaintFirstSon(Node *current, wxBufferedPaintDC *dc){
    wxBrush brush1(wxColour(181, 165, 213));
  //wxBrush brush1(wxColour(0, 0, 255));
 wxBrush brush2(wxColour(130, 130, 130));
        //wxBrush brush2(wxColour(255, 0, 0));
        
    wxPoint p;

    while(current->FirstSon != NULL){
        //Node *father = current;
        current = current->FirstSon;//ak nema syna tak sirka std inak 2^k*
        p.x = current->x;
        p.y = current->y;
        p = ChangeToAbsolute(current->Father, p);
        if (current->FirstSon == NULL){
            
            if((current == curnode)&&(!editEdgeMode)||((editEdgeMode)&&(curedge!=NULL)&&((current == curedge->Source)||(current == curedge->Target)))){    
                dc->SetBrush(brush2);
                dc->DrawEllipse(p.x - current->Width/2, p.y - current->Height/2, current->Width, current->Height);
                
            }else{
                dc->SetBrush(brush1);
                dc->DrawEllipse(p.x - current->Width/2, p.y - current->Height/2, current->Width, current->Height);
            }   
        }else{
            if((current == curnode)&&(!editEdgeMode)||((editEdgeMode)&&(curedge!=NULL)&&((current == curedge->Source)||(current == curedge->Target)))){    
                dc->SetBrush(brush2);
                dc->DrawRoundedRectangle(p.x - current->Width/2, p.y - current->Height/2, current->Width, current->Height,4);
                
            }else{
                dc->SetBrush(brush1);
                dc->DrawRoundedRectangle(p.x - current->Width/2, p.y - current->Height/2, current->Width, current->Height,4);
            }
            
        }   
        Node *current2 = current;
        while(current2->RightBrother != NULL){
            current2 = current2->RightBrother;
            p.x = current2->x;
            p.y = current2->y;
            p = ChangeToAbsolute(current2->Father, p);
            if (current2->FirstSon == NULL){
                if((current2 == curnode)&&(!editEdgeMode)||((editEdgeMode)&&(curedge!=NULL)&&((current2 == curedge->Source)||(current2 == curedge->Target)))){    
                    dc->SetBrush(brush2);
                    dc->DrawEllipse(p.x - current2->Width/2, p.y - current2->Height/2, current2->Width, current2->Height);
                    
                }else{
                    dc->SetBrush(brush1);
                    dc->DrawEllipse(p.x - current2->Width/2, p.y - current2->Height/2, current2->Width, current2->Height);
                }
                
                
            }else{
                if((current2 == curnode)&&(!editEdgeMode)||((editEdgeMode)&&(curedge!=NULL)&&((current2 == curedge->Source)||(current2 == curedge->Target)))){    
                    dc->SetBrush(brush2);
                    dc->DrawRoundedRectangle(p.x - current2->Width/2, p.y - current2->Height/2, current2->Width, current2->Height,4);
                    
                }else{
                    dc->SetBrush(brush1);
                    dc->DrawRoundedRectangle(p.x - current2->Width/2, p.y - current2->Height/2, current2->Width, current2->Height,4);
                }
                
            }   
            
            //dc->DrawEllipse(int(k*(current2->x)) - current2->Width/2, int(k*(current2->y)) - current2->Height/2, current2->Width, current2->Height);
            PaintFirstSon(current2, dc);
            //PaintRightBrother(current, dc);
            //paintson
        } 
    }   
}


wxPoint MyGraph::DeleteNode(Node *curnode1){
    wxPoint p;
    p.x = curnode1->x;
    p.y = curnode1->y;
    
           

    
    if(curnode1->Father != NULL){
        p = ChangeToAbsolute(curnode1->Father, p);
    }
    //vymaz deti
   // bool arechildren = (curnode->FirstSon != NULL);
    Node *n=curnode1;
    if(n->FirstSon != NULL){
        n= n->FirstSon;
        while(n->RightBrother != NULL){
            
            n = n->RightBrother;
            DeleteNode(n->LeftBrother);
        }
        
        DeleteNode(n);
    }
  //  while((n!=NULL)&&(n != curnode1)){
//        
//        while(n->FirstSon != NULL){
//            n = n->FirstSon;    
//        }
//        if(n->RightBrother != NULL){
//            n->Father->FirstSon = n->RightBrother;
//            n = n->RightBrother;
//            DeleteAllEdges(n->LeftBrother);
//            delete n->LeftBrother;
//        }else{
//            n = n->Father;
//            DeleteAllEdges(n->FirstSon);
//            delete n->FirstSon;
//        }
//               
//    }
    //vymaz hrany
    
    //vymaz vrchol
    if(curnode1->LeftBrother!=NULL){
        curnode1->LeftBrother->RightBrother = curnode1->RightBrother;
    }else{
        if(curnode1->Father!=NULL){
            curnode1->Father->FirstSon = curnode1->RightBrother;
        }
    } 
    if(curnode1->RightBrother!=NULL){
        curnode1->RightBrother->LeftBrother = curnode1->LeftBrother;
    }
    DeleteAllEdges(curnode1);
    
    if(curnode1 == base){
        delete curnode1;
        base = new Node();
        curnode = base;
       //uppernode = NULL;
       //stdtolerant = 6;
       numedge = 0;
       number = 0;
       //stdWidth = 40;
       //stdHeight = 40;
       //minWib = 10;  //minimalne medzery medzi vrcholmi
       //minHeb = 10;
       base->id = number;
       base->LeftBrother = NULL;
       base->RightBrother = NULL;
       base->FirstSon = NULL;
 //      base->LastSon = NULL;
       base->Father = NULL;
       base->next = NULL;
       base->x = 0;
       base->y = 0;
       base->Width = 0;
       base->Height = 0;
        base->collapsed = false;
       // base->back=false;
        //insertMode = true;
        //editMode = false;
        //editEdgeMode = false;
        //number++;
        //strrr = "kgjjj";
    }else{
        delete curnode1;
    }
    
    
     

    return p;
    
    
    }     

void MyGraph::MakeEdge(Node *source, Node *target){
        //zakazane hrany na vsetkych nasledovnikov a predkov
        Node *n;
        bool noEdge = false;
        if(source->id > target->id){
            n = source; 
            while(n->Father != NULL){
                n = n->Father;
                if(n == target){
                    noEdge = true;
                }
                
            }       
        }else{
            n = target;
            while(n != NULL){
                if(n == source){
                    noEdge = true;
                }
                n = n->Father;
            }    
        }
        if(!noEdge){
            Edge *e = new Edge();
            numedge++;
            e->id = numedge;
            
            e->Source = source;
            e->Target = target;
            wxPoint s;
            wxPoint t;
            s.x = e->Source->x;
            s.y = e->Source->y + e->Source->Height/2;
            t.x = e->Target->x;
            t.y = e->Target->y - e->Target->Height/2;
            if(e->Source->Father != NULL){
                s = ChangeToAbsolute(e->Source->Father, s);
            }
            if(e->Target->Father != NULL){
                t = ChangeToAbsolute(e->Target->Father, t);
            }
            e->l = MakeLineEquation(s,t);
            //vytvor index vo vrcholoch, ake hrany su s nim spojene
            Pedge *ppp =source->next;
            if(ppp == NULL){
                source->next = new Pedge();
                source->next->id = e->id;
                source->next->in = false;
                source->next->prev = NULL;
                source->next->next = NULL;
            }else{
                while (ppp->next!=NULL){
                    ppp = ppp->next;    
                }
                ppp->next = new Pedge();
                ppp->next->id = e->id;
                ppp->next->in = false;
                ppp->next->prev = ppp;
                ppp->next->next = NULL;    
            }
            
            ppp=target->next;
            if(ppp == NULL){
                target->next = new Pedge();
                target->next->id = e->id;
                target->next->in = true;
                target->next->prev = NULL;
                target->next->next = NULL;
            }else{
                while (ppp->next!=NULL){
                    ppp = ppp->next;    
                }
                ppp->next = new Pedge();
                ppp->next->id = e->id;
                ppp->next->in = true;
                ppp->next->prev = ppp;
                ppp->next->next = NULL;    
            }
            edges.insert( pair<int,Edge*>(e->id,e) );
 
        }  

    
    }
wxPoint MyGraph::ArrowPosition(float d, float k, float q, wxPoint p, bool toLeft){
    //wxPoint pp;
    
    if(toLeft){
       // pp.x= 2*p.x-pp.x;    
       p.x = (int)((p.x+k*(p.y-q)-sqrt(pow(d,2)*(1+pow(k,2))-pow(p.y,2)-pow(q,2)-pow(p.x,2)*pow(k,2)+2*(q*p.y+k*p.x*(p.y-q))))/(pow(k,2)+1));
    
    }else{
        p.x = (int)((p.x+k*(p.y-q)+sqrt(pow(d,2)*(1+pow(k,2))-pow(p.y,2)-pow(q,2)-pow(p.x,2)*pow(k,2)+2*(q*p.y+k*p.x*(p.y-q))))/(pow(k,2)+1));
    }   
    p.y = (int)(k*p.x + q);
    
    return p;
    
}

wxPoint MyGraph::Inverse(wxPoint p){
    int v;
    v = p.x;
    p.x = p.y;
    p.y = v;
    return p;    
}
    
void MyGraph::PrintEdges(wxBufferedPaintDC *dc){
        wxPoint p;
        wxPoint pp;
        wxPoint r;  
        for ( it=edges.begin() ; it != edges.end(); it++ ){
            //cout << (*it).first << " => " << (*it).second << endl;
       
            p.x = it->second->Source->x;
            p.y = it->second->Source->y + it->second->Source->Height / 2;
            if(it->second->Source->Father != NULL){
                p = ChangeToAbsolute(it->second->Source->Father, p);
            }
            pp.x = it->second->Target->x;
            pp.y = it->second->Target->y - it->second->Target->Height / 2;
            if(it->second->Target->Father != NULL){
                pp = ChangeToAbsolute(it->second->Target->Father, pp);
            }
            

            wxPoint sp[4];
            bool toLeft = p.x<pp.x;
            
            
            
                wxPoint s;
                wxPoint tt;
                Line *l = new Line();
    wxPoint t;
            Edge *e = it->second;
    s.x = e->Source->x;//body hrany, pre ktore potrebujeme rovnicu priamky a sipku
    s.y = e->Source->y + e->Source->Height/2;
    t.x = e->Target->x;
    t.y = e->Target->y - e->Target->Height/2;
    if((e->l->k > 1)||(e->l->k< -1)){
        if(e->Source->Father != NULL){
                s = ChangeToAbsolute(e->Source->Father, s);
            }
        if(e->Target->Father != NULL){
            t = ChangeToAbsolute(e->Target->Father, t);
        }
        t = Inverse(t);
        s = Inverse(s);
        //v= t.x;//inverzn funkcia
//        t.x = t.y;
//        t.y = v;
//        v = s.x;
//        s.x = s.y;
//        s.y = v;
         
        l = MakeLineEquation(s, t);
    
        tt = t;
        toLeft = s.x<t.x;
        s = ArrowPosition(13.0, l->k, l->q + 6, tt, toLeft);
            sp[0].x = s.x;//-13 ;//50;
            sp[0].y = s.y;//-6;//50;
            sp[1].x = tt.x;//63;
            sp[1].y = tt.y+1;//56;
            t = ArrowPosition(13.0, l->k, l->q - 6, tt, toLeft);
            sp[2].x = t.x;//-13;//50;
            sp[2].y = t.y;//+6;//62;
            t = ArrowPosition(8.0, l->k, l->q, tt, toLeft);
            sp[3].x = t.x;//55;
            sp[3].y = t.y;//56;
        
           sp[0]= Inverse(sp[0]);
           sp[1]= Inverse(sp[1]);
           sp[2]= Inverse(sp[2]);
           sp[3]= Inverse(sp[3]);   
//           v=sp[0].x; //inverzn funkcia
//        sp[0].x = sp[0].y;
//        sp[0].y = v;
//        v=sp[1].x; 
//        sp[1].x = sp[1].y;
//        sp[1].y = v;
//        v=sp[2].x; 
//        sp[2].x = sp[2].y;
//        sp[2].y = v;
//        v=sp[3].x; 
//        sp[3].x = sp[3].y;
//        sp[3].y = v;
        
        //dc->DrawPolygon(4, sp);
        
    }else{
            r = ArrowPosition(13.0, it->second->l->k, it->second->l->q + 6, pp, toLeft);
            sp[0].x = r.x;//-13 ;//50;
            sp[0].y = r.y;//-6;//50;
            sp[1].x = pp.x;//63;
            sp[1].y = pp.y+1;//56;
            r = ArrowPosition(13.0, it->second->l->k, it->second->l->q - 6, pp, toLeft);
            sp[2].x = r.x;//-13;//50;
            sp[2].y = r.y;//+6;//62;
            r = ArrowPosition(8.0, it->second->l->k, it->second->l->q, pp, toLeft);
            sp[3].x = r.x;//55;
            sp[3].y = r.y;//56;
            
        }
        
        wxPen pen1(wxColour(0, 0, 0), 2);
        wxPen pen2(wxColour(255, 0, 0), 2); 
        wxBrush brush4(wxColour(0, 0, 0));
        wxBrush brush5(wxColour(255, 0, 0));    
        if((it->second == curedge)&&(!editMode)&&(editEdgeMode)){
            dc->SetPen(pen2); 
            dc->SetBrush(brush5);   
        }else{
            dc->SetPen(pen1);
            dc->SetBrush(brush4);
        }
        dc->DrawLine(p.x, p.y, pp.x, pp.y);     
        dc->DrawPolygon(4, sp);
          //  for(p.x = 0; p.x<base->Width; p.x++){
//                
//                p.y = int(it->second->l->k*p.x+it->second->l->q);
//                dc->DrawPoint(p);    
//            }
            
            
            
            //if(it->second->k==0){
//                p.x= it->second->q;
//                dc->DrawLine(p.x, 0, p.x, base->Height);    
//            }

        }
    wxPen pen(wxColour(0, 0, 0), 1);
    dc->SetPen(pen);

    
    
    }
Line *MyGraph::MakeLineEquation(wxPoint s, wxPoint t){
   // wxPoint s;
   // wxPoint t;
    //s.x = e->Source->x;
//    s.y = e->Source->y + e->Source->Height/2;
//    t.x = e->Target->x;
//    t.y = e->Target->y - e->Target->Height/2;
//    if(e->Source->Father != NULL){
//        s = ChangeToAbsolute(e->Source->Father, s);
//    }
//    if(e->Target->Father != NULL){
//        t = ChangeToAbsolute(e->Target->Father, t);
//    }
            //e->qq = ;
    Line *l= new Line();
    l->q = (s.y-((float)s.x/(float)t.x*t.y))/(1 - (float)s.x/(float)t.x);
    l->k = (s.y - l->q)/(s.x);
//    if(s.y==t.y){
//        l->q = (s.y-((float)s.x/(float)t.x*t.y))/(1 - (float)s.x/(float)t.x);
//        l->k = 0;   
//    }
    //int v;

             //   t = ArrowPosition(8.0, e->k, e->q, t, s.x<t.x);
//
               

//        
//    if((e->k > 1)||(e->k< -1)){
//        v= t.x;
//        t.x = t.y;
//        t.y = v;
//        v = s.x;
//        s.x = s.y;
//        s.y = v;
//        e->k = 1/e->k;  
//        e->q = -e->q*e->k;       
//    }
    return l;
    
    
    }
    
    //vstup: absolutne suradnice
    //vystup: null alebo hrana na ktoru sme klikli...
    Edge *MyGraph::FindEdge(wxPoint ppp){
        Edge *e;
        wxPoint p;
        wxPoint pp;
        wxPoint point = ppp;
        Line *l = new Line();
        std::stringstream out;
        bool inv= false;
        int ii;
        
        for ( it=edges.begin() ; it != edges.end(); it++ ){
            ppp = point;
            e = it->second;
            p.x = e->Source->x;
            p.y = e->Source->y + e->Source->Height / 2;
            if(e->Source->Father != NULL){
                p = ChangeToAbsolute(e->Source->Father, p);
            }
            pp.x = e->Target->x;
            pp.y = e->Target->y - e->Target->Height / 2;
            if(e->Target->Father != NULL){
                pp = ChangeToAbsolute(e->Target->Father, pp);
            }
            l = e->l;
            if((l->k > 1)||(l->k< -1)){
                p = Inverse(p);
                pp = Inverse(pp);
                ppp = Inverse(ppp);
                l = MakeLineEquation(p, pp);
                inv = true;
            }

            
            if(((p.x <= ppp.x)&&(ppp.x <= pp.x))
            ||((pp.x <= ppp.x)&&(ppp.x <= p.x))
            ||((abs(p.x - pp.x)<2*stdtolerant)&&(ppp.x > p.x-stdtolerant)&&(ppp.x < p.x+stdtolerant))){
                if(((p.y <= ppp.y)&&(ppp.y <= pp.y))
                ||((pp.y <= ppp.y)&&(ppp.y <= p.y))
                ||((abs(p.y - pp.y)<2*stdtolerant)&&(ppp.y > p.y-stdtolerant)&&(ppp.y < p.y+stdtolerant))){
                    
        out << (int)p.x;
        out << ", ";
        out << (int)pp.x;
        out << ", ";
             ii= (int)(ppp.x*l->k + l->q);       
        out << ii;
        ii =  ppp.y-stdtolerant;
        out << ", ";
        out << ii;


        ii =  ppp.y+stdtolerant;
        out << ", ";
        out << ii;
        out << ", ";
        out << l->q;//n->x;
        out << ", ";
        out << l->k;//n->y;
        

        //out << e->qq;
        //strrr = out.str();
                    
                    if((ppp.x*l->k + l->q > ppp.y-stdtolerant)&&(ppp.x*l->k + l->q < ppp.y + stdtolerant)){
                        if(inv){
                            p = Inverse(p);
                pp = Inverse(pp);
                ppp = Inverse(ppp);
                l = MakeLineEquation(p, pp);    
                        }
                        
                        return e;   
                    }   
                }
            }
            
        }
        
        
        return NULL;
}
void MyGraph::DeleteEdge(Edge *e){
    Pedge *pe = e->Source->next;//vymaz zaznam vo vrchole source
    Pedge *ped;
    if((pe!= NULL)&&(pe->id == e->id)){
        e->Source->next = pe->next; 
        ped = pe;
    }else{    
        while((pe->next != NULL)&&(pe->next->id != e->id)){
            pe = pe->next;    
        }
        ped = pe->next;
        pe->next = pe->next->next;
    }
    delete ped;
    //vymaz zaznam vo vrchole target
    pe = e->Target->next;
    if((pe!= NULL)&&(pe->id == e->id)){
        e->Target->next = pe->next; 
        ped = pe;
    }else{    
        while((pe->next != NULL)&&(pe->next->id != e->id)){
            pe = pe->next;    
        }
        ped = pe->next;
        pe->next = pe->next->next;  
    }
    delete ped;
    //vymaz zaznam v edges
    edges.erase(edges.find(e->id));
    delete e->l;
    delete e;
    
}        
        
        
void MyGraph::DeleteAllEdges(Node *n){     
    Edge *e ;
    Pedge *pe;
    Pedge *pee;
    Pedge *ped;
    pe = n->next;
    n->next = NULL;
    

    while(pe != NULL){
        e = edges.find(pe->id)->second;    
        ped = pe;
        pe = pe->next;
        delete ped;   
        
        if(e->Source == n){
            pee = e->Target->next;
            if((pee!= NULL)&&(pee->id == e->id)){
                e->Target->next = pee->next; 
                ped = pee;
            }else{    
                while((pee->next != NULL)&&(pee->next->id != e->id)){
                    pee = pee->next;    
                }
                ped = pee->next;
                pee->next = pee->next->next;
            }
        }else{
            pee = e->Source->next;
            if((pee!= NULL)&&(pee->id == e->id)){
                e->Source->next = pee->next; 
                ped = pee;
            }else{    
                while((pee->next != NULL)&&(pee->next->id != e->id)){
                    pee = pee->next;    
                }
                ped = pee->next;
                pee->next = pee->next->next;
            }
        }
        delete ped;
        edges.erase(edges.find(e->id));
        delete e->l;
        delete e;

    }
        
    
    
}



bool MyGraph::ImportGraph(TiXmlDocument doc, int w, int h){
    
    
    //vymaz stary graf
    DeleteNode(base);
    //numedge = 0;

 
    bool viewMode = false;
    TiXmlHandle hDoc(&doc);
	TiXmlElement* pElem;
	TiXmlHandle hRoot(0);
	map<wxString, int> nodes;
    map<wxString, int>::iterator itn;
    pair<map<wxString, int>::iterator,bool> retn;
    
    map<wxString, wxString> keys;
    map<wxString, wxString>::iterator itnn;
    pair<map<wxString, wxString>::iterator,bool> retnn;
    pElem=hDoc.FirstChildElement("graphml").Element();
		// should always have a valid root but handle gracefully if it does
	//if (!pElem) return false;
	if(pElem == 0) return false;
	string str = pElem->Value();
	//if("graphml"!= str.substr(0,7)) return false;    
   
	hRoot=TiXmlHandle(pElem);
    std::stringstream out;
    wxString att;
    wxString o  = "1345";
    ////nacitanie key elementov
    TiXmlElement* keyel = hRoot.FirstChild("key").Element();
     if (keyel == 0){
        if(hRoot.FirstChildElement().Element() != 0){
            keyel = hRoot.FirstChildElement().Element()->NextSiblingElement("key");
        }
    }
    if(keyel !=0){
    for( keyel; keyel; keyel=keyel->NextSiblingElement("key") ){
        //out << keyel->Attribute("for");
        if(keyel->Attribute("for") != NULL){
            att = keyel->Attribute("for");
        }else{att = "";}    
        if((att == "node")||(att == "all")||(att=="")){
            //out << "bb";
            if(keyel->Attribute("attr.name") != NULL){
                att = keyel->Attribute("attr.name");
                if((att=="x")||
                (att=="y")||
                (att=="width")||
                (att=="height")){
                //out << "$$";
                    keys.insert(pair<wxString,wxString>(keyel->Attribute("id"), keyel->Attribute("attr.name")));
                }
            }
        }
        
        if(keyel->Attribute("for") != NULL){
            att = keyel->Attribute("for");
        }else{att = "";}
        if((att == "edge")||(att == "all")||(att=="")){
            if(keyel->Attribute("attr.name") != NULL){
                att = keyel->Attribute("attr.name");
                if((att=="source")||
                (att=="target")){//||
            //(keyel->Attribute("attr.name")=="width")||
            //(keyel->Attribute("attr.name")=="height")){
                    keys.insert(pair<wxString,wxString>(keyel->Attribute("id"), keyel->Attribute("attr.name")));
                }
            }
         //   switch(keyel->Attribute("attr.name"))
//                case "x":
//                break;
//                case "y":
//                break;
//                case "width":
//                break;
//                case "height":
//                break;
        }        
        
        
    }
    }
    
 //   for ( itnn=keys.begin() ; itnn != keys.end(); itnn++ ){
//          out << itnn->first;
//          out << ", ";
//          out << itnn->second;
//          out << ";";
//        }


     // 
    //out << keys.find("d1")->second;
    
   ////nacitanie grafu 
    TiXmlElement* graphel = hRoot.FirstChild("graph").Element();
    if (graphel == 0){
        graphel = hRoot.FirstChild().Element()->NextSiblingElement("graph");
    }
	//graphel=graphel->NextSiblingElement("graph"); 
	
	base->Width = w;
    base->Height = h;
    base->x = base->Width/2;
    base->y = base->Height/2;
    number++;
    
    TiXmlElement* data;
      if(graphel->FirstChildElement("data") != 0){
        data = graphel->FirstChildElement("data");
        }
		if((graphel->FirstChildElement("data") == 0)&&(graphel->FirstChildElement() != 0)){
            data = graphel->FirstChildElement()->NextSiblingElement("data");    
        }
       
        if(data != 0){
            //data = nodel->FirstChildElement("data");
            for( data; data; data=data->NextSiblingElement("data") ){
                o = data->GetText();
                //i = atoi(o.c_str());
                //out << i;
                //out << data->Attribute("key");
 //               out << keys.find("d1")->second;
 
                if(keys.find(data->Attribute("key")) != keys.end()){
                    if(keys.find(data->Attribute("key"))->second == "width") base->Width = atoi(o.c_str());
                    if(keys.find(data->Attribute("key"))->second == "height") base->Height = atoi(o.c_str());
                }
            }
        }
    
    
    if(graphel != 0){
        nodes.insert( pair<wxString,int>(graphel->Attribute("id") ,0) );
        nodes = ParseGraph(graphel, nodes, keys, viewMode);//strrr = out.str();
        strrr = out.str();
        return true;
    }
    return false;//chyba element graph
}   
    
map<wxString, int> MyGraph::ParseGraph(TiXmlElement* graphel, map<wxString, int> nodes, map<wxString, wxString> keys, bool viewMode){
   
    TiXmlElement* data = 0;   
    TiXmlElement* nodel = graphel->FirstChildElement("node"); 
    
    if (graphel->FirstChildElement()!=0){
    if (nodel == 0){
        //je vnoreny graf
        nodel = graphel->FirstChildElement("graph")->FirstChildElement("node");
    }
    if (nodel == 0){
        nodel= graphel->FirstChildElement()->NextSiblingElement("node");
    }// vrchol nie je prvy element
    }
    Node* n;
    Node* nn;
    bool defaultt;
    
    wxString o  = "1345";
  //  istringstream myStream(o);
    int i;
    int w;
    int h;
    //myStream>>i;
    //i = atoi(o.c_str());
 
     std::stringstream out;
    wxPoint p;
    if(nodel != 0){
    for( nodel; nodel; nodel=nodel->NextSiblingElement("node") )
	{
        if(nodel->Attribute("X")!=NULL){
            viewMode = true;
        }
        
        n =FindNode(nodes.find(graphel->Attribute("id"))->second);
        defaultt = true;
        if(!viewMode){
            p.x = n->x + FindNode(0)->x - FindNode(0)->Width/2;
            p.y = n->y + FindNode(0)->y - FindNode(0)->Height/2;
            if(n->Father != NULL){
                p = ChangeToAbsolute(n->Father, p);
            }
            w = stdWidth;
            h = stdHeight;
        }else{
            o= nodel->Attribute("X");
            p.x = atoi(o.c_str());
            o= nodel->Attribute("Y");
            p.y = atoi(o.c_str());
            o= nodel->Attribute("Width");
            w = atoi(o.c_str());
            o= nodel->Attribute("Height");
            h = atoi(o.c_str());    
        }
        
        
        if(nodel->FirstChildElement("data") != 0){
        data = nodel->FirstChildElement("data");
        }
		if((nodel->FirstChildElement("data") == 0)&&(nodel->FirstChildElement() != 0)){
            data = nodel->FirstChildElement()->NextSiblingElement("data");    
        }
       
        if(data != 0){
            //data = nodel->FirstChildElement("data");
            for( data; data; data=data->NextSiblingElement("data") ){
                o = data->GetText();
                //i = atoi(o.c_str());
                //out << i;
                //out << data->Attribute("key");
 //               out << keys.find("d1")->second;
 
                if((!viewMode)&&(keys.find(data->Attribute("key")) != keys.end())){
                    if(keys.find(data->Attribute("key"))->second == "x") p.x = atoi(o.c_str())  + FindNode(0)->x - FindNode(0)->Width/2;//;
                    if(keys.find(data->Attribute("key"))->second == "y") p.y = atoi(o.c_str())  + FindNode(0)->y - FindNode(0)->Height/2;
                    if(keys.find(data->Attribute("key"))->second == "width") w = atoi(o.c_str());
                    if(keys.find(data->Attribute("key"))->second == "height") h = atoi(o.c_str());
                    defaultt = false;
                }
            }
            
        }
		
        //wxString ss = ;
        
        //int jj = nodes.find(nodel->Parent()->ToElement()->Attribute("id"))->second;
        //out << jj;
        //std::stringstream out;
        //if (n!= NULL){
          //  out << n->id;
            //out << ", ";
            
        //}
        //if(stdWidth > w){stdWidth = w;}
        //if(stdHeight > h){stdHeight = h;}
        //p = ChangeToRelative(n, p);
        i = push(p, w, h, n);
        if ((defaultt)&&(!viewMode)){
            EmBiggerNode(FindNode(i),n);
        }
        if (nodel->Attribute("id")!=NULL){
            nodes.insert( pair<wxString,int>(nodel->Attribute("id"), i) );
        } 
        if((nodel->FirstChildElement("graph")!=0)||((nodel->FirstChildElement()!=0)&&(nodel->FirstChildElement()->NextSiblingElement("graph")!=0))){
            nodes = ParseGraph( nodel, nodes, keys, viewMode);
         //out << "@";
        }
	}
    }
	//strrr += out.str();
	
	
    TiXmlElement* edgel = graphel->FirstChildElement("edge");
    if (graphel->FirstChildElement() != 0){
    if (graphel->FirstChildElement("graph") != 0){    
        if (edgel == 0){
            edgel = graphel->FirstChildElement("graph")->FirstChildElement("edge");
        }
    }
    if (edgel == 0){
        edgel= graphel->FirstChildElement()->NextSiblingElement("edge");
    }
    }
      //  for ( itn=nodes.begin() ; itn != nodes.end(); itn++ ){
//          out << itn->first;
//          out << ", ";
//          out << itn->second;
//          out << ";";
//        }
   //edgel=edgel->NextSiblingElement();
    if(edgel != 0){
    for( edgel; edgel; edgel=edgel->NextSiblingElement("edge") )
	{
		//;
		
	//	while(true){
            
      //  }
  
     // wxString ss = ;
//      out << "##";
//      out << ss;
//      out << "##";
      i = nodes.find(edgel->Attribute("source"))->second;
		n =FindNode(i);
		
        if (n== NULL){
            out << "n, ";
            out << i;
        }
	    i=	nodes.find(edgel->Attribute("target"))->second;
	    
	    
		nn =FindNode(i);
		 if (nn== NULL){
            out << "nn, ";
            out << i;
        }
        //
	    MakeEdge(n, nn);
	         //if(n->Father != NULL){
              //  out << n->id;
                //n = n->Father;
                
               // if(n == target){
                 //   noEdge = true;
                //}
                
            //}
            
		//wxPoint p;
        //p.x = base->x;
        //p.y = base->y;
		//push(p);
	}
    }
    strrr = out.str();
    return nodes;
}

bool MyGraph::ExportGraph( TiXmlDocument doc){
    nodesel.clear();
    std::stringstream out;
    wxString ss;
    int num = 0;
    int nume = 0;
    
    TiXmlDeclaration* decl = new TiXmlDeclaration( "1.0", "UTF-8", "" ); 
    doc.LinkEndChild( decl );
    TiXmlElement * root = new TiXmlElement( "graphml" ); 
    root->SetAttribute("xmlns","http://graphml.graphdrawing.org/xmlns");
    root->SetAttribute("xmlns:xsi","http://www.w3.org/2001/XMLSchema-instance");
    root->SetAttribute("xmlns","http://graphml.graphdrawing.org/xmlns http://graphml.graphdrawing.org/xmlns/1.0/graphml.xsd");
	doc.LinkEndChild( root );
	
	TiXmlElement * key = new TiXmlElement( "key" );
	key->SetAttribute("id","d0");
	key->SetAttribute("for","node");
	key->SetAttribute("attr.name","x");
	key->SetAttribute("attr.type","int");
	root->LinkEndChild( key );
	
	key = new TiXmlElement( "key" );
	key->SetAttribute("id","d1");
	key->SetAttribute("for","node");
	key->SetAttribute("attr.name","y");
	key->SetAttribute("attr.type","int");
	root->LinkEndChild( key );
	
	key = new TiXmlElement( "key" );
	key->SetAttribute("id","d2");
	key->SetAttribute("for","all");
	key->SetAttribute("attr.name","width");
	key->SetAttribute("attr.type","int");
	root->LinkEndChild( key );
	
	key = new TiXmlElement( "key" );
	key->SetAttribute("id","d3");
	key->SetAttribute("for","all");
	key->SetAttribute("attr.name","height");
	key->SetAttribute("attr.type","int");
	root->LinkEndChild( key );
	
	TiXmlElement * graf = new TiXmlElement( "graph" );
    graf->SetAttribute("id","G");
    graf->SetAttribute("edgedefault","directed");
    nodesel.insert( pair<int,wxString>(0, graf->Attribute("id")));
    root->LinkEndChild( graf );
    
    Node *fnode = base;
    
    TiXmlElement * data = new TiXmlElement( "data" );
    data->SetAttribute("key", "d2");
    out.str("");
    out << fnode->Width;
    ss = out.str();
    data->LinkEndChild(new TiXmlText(ss));
    graf->LinkEndChild(data);
    
    data = new TiXmlElement( "data" );
    data->SetAttribute("key", "d3");
    out.str("");
    out << fnode->Height;
    ss = out.str();
    data->LinkEndChild(new TiXmlText(ss));
    graf->LinkEndChild(data);
    
    
    //TiXmlElement * node;
    
    
    
    if(fnode->FirstSon != NULL){

        num = 0;
        graf->LinkEndChild(Linknode(fnode->FirstSon, num, ""));
        fnode = fnode->FirstSon;
        
        while(fnode->RightBrother != NULL){
            graf->LinkEndChild(Linknode(fnode->RightBrother, ++num, ""));
        
            fnode = fnode->RightBrother;
        }
        
    }
    
    for ( it=edges.begin() ; it !=edges.end(); it++ ){
        TiXmlElement * edge = new TiXmlElement( "edge" );
        out.str("");
        out << "e";
        out << nume;
        nume++;
        ss = out.str();
        edge->SetAttribute("id", ss);
        ss = nodesel.find(it->second->Source->id)->second;
        edge->SetAttribute("source", ss);
        ss = nodesel.find(it->second->Target->id)->second;
        edge->SetAttribute("target", ss);
        graf->LinkEndChild(edge);
        
            
    }
    
    
    
    
    //doc.LoadFile();
  //TiXmlPrinter printer;
    //doc.Accept( &printer );  
//    map<int, wxString>::iterator itr;
//        for ( itr=nodesel.begin() ; itr != nodesel.end(); itr++ ){
//          out << itr->first;
//          out << ", ";
//          out << itr->second;
//          out << ";";
//        }
//strrr=out.str();
    
    return doc.SaveFile();  

}

TiXmlElement *MyGraph::Linknode(Node *fnode, int num, wxString prefix){
    std::stringstream out;
    wxString ss;
    
    TiXmlElement *node = new TiXmlElement( "node" );
    out.str("");
    out << prefix;
    out << "n";
    out << num;
    //num++;
    ss = out.str();
    node->SetAttribute("id", ss);
    nodesel.insert( pair<int,wxString>(fnode->id, node->Attribute("id")));
    prefix = ss;
    wxPoint p;
    p.x =fnode->x;
    p.y =fnode->y;
    if(fnode->Father != NULL){
        p = ChangeToAbsolute(fnode->Father, p);
    }
    TiXmlElement *data = new TiXmlElement( "data" );
    data->SetAttribute("key", "d0");
    out.str("");
    out << p.x;
    ss = out.str();
    data->LinkEndChild(new TiXmlText(ss));
    node->LinkEndChild(data);
    
    data = new TiXmlElement( "data" );
    data->SetAttribute("key", "d1");
    out.str("");
    out << p.y;
    ss = out.str();
    data->LinkEndChild(new TiXmlText(ss));
    node->LinkEndChild(data);
    
    data = new TiXmlElement( "data" );
    data->SetAttribute("key", "d2");
    out.str("");
    out << fnode->Width;
    ss = out.str();
    data->LinkEndChild(new TiXmlText(ss));
    node->LinkEndChild(data);
    
    data = new TiXmlElement( "data" );
    data->SetAttribute("key", "d3");
    out.str("");
    out << fnode->Height;
    ss = out.str();
    data->LinkEndChild(new TiXmlText(ss));
    node->LinkEndChild(data);
    //out << "::";
    //prefix = out;
    
    if(fnode->FirstSon != NULL){
        TiXmlElement * graf1 = new TiXmlElement( "graph" );
        out.str("");
        out << prefix; // out ma n5
        //out << "n";
        //out << nodesel.find(fnode->id)->second;
        out << ":";
        ss = out.str();
        graf1->SetAttribute("id", ss);
        graf1->SetAttribute("edgedefault","directed");
    //node = graf1;
    //graf->LinkEndChild(node);
        node->LinkEndChild( graf1 );
        out << ":";
        num = 0;
        graf1->LinkEndChild(Linknode(fnode->FirstSon, num, out.str()));
        fnode = fnode->FirstSon;
        
        while(fnode->RightBrother != NULL){
            graf1->LinkEndChild(Linknode(fnode->RightBrother, ++num, out.str()));
        
            fnode = fnode->RightBrother;
        }
        
    }
    
    return node;
    
    //graf1->LinkEndChild( node );
    
    
    }
